# tools_install

this is a package template for third party tools install.

在`bundle.json`中添加自定义字段 `installConfig`：

```json
{
    "installConfig": {
        "win": "http://xxxxxxxxxx/mirrors/gn/xxxx/win/gn.xxxx.tar",
        "linux": "http://xxxxxxxxxx/mirrors/gn/xxxx/linux/gn.xxxx.tar",
        "darwin": "http://xxxxxxxxxx/mirrors/gn/xxxx/darwin/gn.xxxx.tar",
        "envNameSpace": "HPM_GN_INSTALL_TEST"
    }
}
```

- `win`,`linux`,`darwin`视工具工作系统至少填一项，分别表示**不同系统**的工具包下载地址,如所有系统共用一个工具包下载地址 则需要每个都填写一样的地址。

- `envNameSpace` 必填，表示配置在.hpmrc中的下载后的解压地址的变量的**变量名**。envNameSpace默认为当前工具bundle名大写。而该变量名的值也就是工具安装位置默认为当前bundle目录

eg: 

bundle.json
```
{
    name:'devtools'
}
```
envNameSpace默认为
```
DEVTOOLS
```
DEVTOOLS未在.hpmrc中设置路径时 默认为 当前bundle目录

## envNameSpace所设变量名使用

该变量最终会被hpm执行脚本时传递给脚本，在脚本中我们可以使用`${变量名}`来获取工具安装位置，拼接相对路径访问具体文件。

eg:
bundle.json
```
{
    name:'devtools',
    "installConfig": {
        "win": "http://xxxxxxxxxx/mirrors/gn/xxxx/win/gn.xxxx.tar",
        "linux": "http://xxxxxxxxxx/mirrors/gn/xxxx/linux/gn.xxxx.tar",
        "darwin": "http://xxxxxxxxxx/mirrors/gn/xxxx/darwin/gn.xxxx.tar",
        "envNameSpace": "HPM_GN_INSTALL_TEST"
    }
}
```
使用方式
`${HPM_GN_INSTALL_TEST}/gn/gn.exe`

`export PATH=$PATH:${HPM_GN_INSTALL_TEST}/gn`

## 支持解压安装的压缩包类型

- zip
- tar
- tgz
- gzip
