"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.build = build;
exports.startBuild = startBuild;
exports.bundleBuild = bundleBuild;
exports.getValidBuildCmd = getValidBuildCmd;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _worker_threads = require("worker_threads");

var _bundle = require("../core/bundle");

var _constant = require("../constant/constant");

var _repository = require("../core/repository");

var _helpers = require("../utils/helpers");

var _config = require("../utils/config");

var _i18n = _interopRequireWildcard(require("../i18n"));

var _log = _interopRequireDefault(require("../core/log"));

var _events = _interopRequireWildcard(require("../utils/events"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function build(_x, _x2) {
  return _build.apply(this, arguments);
}

function _build() {
  _build = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(commanderObj, customizeArgs) {
    var startBundle, repo;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            startBundle = _bundle.Bundle.from(process.cwd());
            repo = new _repository.Repository(_path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME), (0, _config.getGlobalRepo)());
            _context2.next = 4;
            return startBuild(startBundle, repo, true, customizeArgs);

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _build.apply(this, arguments);
}

var buildCnt = 0;
var needBuildCnt = 0;

function startBuild(startBundle, repo) {
  var useMultipleThread = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var customizeArgs = arguments.length > 3 ? arguments[3] : undefined;
  return new Promise( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(resolve, reject) {
      var bundles, _initDependenciesMap, dependencies, dependents, nameToBundle, _iterator, _step, bundle;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return startBundle.build(repo);

            case 2:
              bundles = _context.sent;
              // 41个组件的情况，从开头到这里都需要很长时间11s，什么情况
              _initDependenciesMap = (0, _helpers.initDependenciesMap)(bundles), dependencies = _initDependenciesMap.dependencies, dependents = _initDependenciesMap.dependents;
              nameToBundle = (0, _bundle.getNameToBundle)(bundles);
              needBuildCnt = bundles.length;

              _events["default"].emit('hooks', {
                type: _events.EventTypes.beforeAllBuild
              });

              _iterator = _createForOfIteratorHelper(bundles);

              try {
                for (_iterator.s(); !(_step = _iterator.n()).done;) {
                  bundle = _step.value;

                  if (useMultipleThread) {
                    if (dependencies.get(bundle.name).size === 0) {
                      startBuildThread(bundle, startBundle.id, dependencies, dependents, nameToBundle, resolve, reject, customizeArgs);
                    }
                  } else {
                    bundleBuild(bundle, bundle.name === startBundle.name, customizeArgs);
                    resolve();
                  }
                }
              } catch (err) {
                _iterator.e(err);
              } finally {
                _iterator.f();
              }

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x3, _x4) {
      return _ref.apply(this, arguments);
    };
  }()).then(function () {
    _i18n["default"].log('build.success');
  }, function (error) {
    process.exitCode = -1;

    _i18n["default"].log('build.error', {
      error: error
    });

    _log["default"].debug(error);
  })["finally"](function () {
    _events["default"].emit('hooks', {
      type: _events.EventTypes.afterAllBuild
    });
  });
}

function startBuildThread(couldStartBundle, firstStartBundleId, dependencies, dependents, nameToBundle, resolve, reject, customizeArgs) {
  var threadEntryFile = _path["default"].join(__dirname, '..', 'thread', 'buildEntry.js');

  _events["default"].emit('hooks', {
    type: _events.EventTypes.beforeEachBuild,
    name: couldStartBundle.name,
    path: couldStartBundle.path
  });

  var worker = new _worker_threads.Worker(threadEntryFile, {
    workerData: {
      // 不可以直接传整个bundle进去，因为没法clone给子对象
      bundlePath: couldStartBundle.path,
      isStartBundle: couldStartBundle.id === firstStartBundleId,
      bundleVarValues: couldStartBundle.vars.values,
      customizeArgs: customizeArgs
    }
  });
  worker.on('exit', function (errCode) {
    if (errCode === 0) {
      _events["default"].emit('hooks', {
        type: _events.EventTypes.afterEachBuild,
        name: couldStartBundle.name,
        path: couldStartBundle.path
      });

      if (++buildCnt === needBuildCnt) {
        resolve();
        return;
      }

      var _iterator2 = _createForOfIteratorHelper(dependents.get(couldStartBundle.name)),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var dependentBuncle = _step2.value;
          // 遍历所有依赖此bundle的bundle
          dependencies.get(dependentBuncle)["delete"](couldStartBundle.name);

          if (dependencies.get(dependentBuncle).size === 0) {
            // 所有依赖都安装好了
            startBuildThread(nameToBundle.get(dependentBuncle), firstStartBundleId, dependencies, dependents, nameToBundle, resolve, reject, customizeArgs);
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    } else {
      reject((0, _i18n.getI18nMessage)('error.workerStop', {
        errCode: errCode
      }));
    }
  });
}

function bundleBuild(bundle, isStartBundle, customizeArgs) {
  var build = getValidBuildCmd(bundle);

  if (build) {
    var preBuildCmd = bundle.scripts(_constant.Hooks.preBuild);

    if (preBuildCmd) {
      (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
        return spawnSync(preBuildCmd, {
          shell: process.env.shellPath,
          env: bundle.vars.env,
          cwd: bundle.path,
          stdio: 'inherit'
        });
      });
    }

    _i18n["default"].log('build.building', {
      name: bundle.manifest.name
    });

    copySegment(bundle);
    linkSegment(bundle);

    if (isStartBundle && customizeArgs && customizeArgs.length > 0) {
      build = "".concat(build, " ").concat(customizeArgs.join(" "));
    }

    (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
      return spawnSync(build, {
        cwd: bundle.path,
        env: bundle.vars.env,
        shell: process.env.shellPath,
        stdio: 'inherit'
      });
    });

    if (!process.exitCode) {
      _i18n["default"].log('build.complete', {
        name: bundle.manifest.name
      });

      var afterBuildCmd = bundle.scripts(_constant.Hooks.afterBuild);

      if (afterBuildCmd) {
        (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
          return spawnSync(afterBuildCmd, {
            shell: process.env.shellPath,
            env: bundle.vars.env,
            cwd: bundle.path,
            stdio: 'inherit'
          });
        });
      }
    }
  }
}

function getValidBuildCmd(bundle) {
  var build = bundle.scripts('build');
  if (bundle.isPublishAs('code-segment')) return null;
  if (!build && bundle.isPublishAs('source')) throw (0, _i18n.getI18nMessage)('build.needScripts', {
    name: bundle.manifest.name
  });
  if (build && typeof build !== 'string') throw (0, _i18n.getI18nMessage)('build.shouldBeCommand', {
    name: bundle.manifest.name
  });
  return build;
}

function copySegment(bundle) {
  var dirs = bundle.copy();
  Object.keys(dirs).forEach(function (key) {
    _i18n["default"].log('build.copyDir', {
      from: dirs[key],
      to: key
    });

    if (!bundle.vars.env || !bundle.vars.env[_constant.DEP_OHOS_BUNDLES] && !bundle.vars.env.globalRepo) {
      throw (0, _i18n.getI18nMessage)('common.noFolder', {
        folderPath: _constant.DEP_FOLDER_NAME
      });
    }

    var source = _path["default"].join(bundle.vars.env[_constant.DEP_OHOS_BUNDLES], dirs[key]);

    if (!_fs["default"].existsSync(source)) {
      source = _path["default"].join(bundle.vars.env.globalRepo, _constant.DEP_FOLDER_NAME, dirs[key]);
    }

    if (_fs["default"].lstatSync(source).isDirectory()) {
      source = _path["default"].join(source, _path["default"].sep, '*');
    }

    var target = _path["default"].join(bundle.path, key);

    (0, _helpers.runShellCmd)(function (shell) {
      return shell.mkdir('-p', target);
    });
    (0, _helpers.runShellCmd)(function (shell) {
      return shell.cp('-R', source, target);
    });
  });
}

function linkSegment(bundle) {
  var dirs = bundle.link();
  dirs.forEach(function (_ref2) {
    var source = _ref2.source,
        target = _ref2.target;

    _i18n["default"].log('build.linkDir', {
      from: source,
      to: target
    });

    if (!bundle.vars.env || !bundle.vars.env[_constant.DEP_OHOS_BUNDLES] && !bundle.vars.env.globalRepo) {
      throw (0, _i18n.getI18nMessage)('common.noFolder', {
        folderPath: _constant.DEP_FOLDER_NAME
      });
    }

    var sourcePath = _path["default"].join(bundle.vars.env[_constant.DEP_OHOS_BUNDLES], source);

    if (!_fs["default"].existsSync(sourcePath)) {
      sourcePath = _path["default"].join(bundle.vars.env.globalRepo, _constant.DEP_FOLDER_NAME, source);
    }

    var targetPath = _path["default"].join(bundle.path, target);

    var targetParent = _path["default"].parse(targetPath);

    if (targetParent.dir) {
      (0, _helpers.runShellCmd)(function (shell) {
        return shell.mkdir('-p', targetParent.dir);
      });
    }

    (0, _helpers.runShellCmd)(function (shell) {
      return shell.ln('-sf', sourcePath, targetPath);
    });
  });
}