"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkUpdate = checkUpdate;
exports.checkUpdateFunction = checkUpdateFunction;

var _path = _interopRequireDefault(require("path"));

var _bundle = require("../core/bundle");

var _repository = require("../core/repository");

var _constant = require("../constant/constant");

var _config = require("../utils/config");

var _i18n = _interopRequireDefault(require("../i18n"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function checkUpdate(_x) {
  return _checkUpdate.apply(this, arguments);
}

function _checkUpdate() {
  _checkUpdate = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options) {
    var repo, bundle, needUpdate;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            repo = null;

            if (options.global) {
              repo = new _repository.Repository('', (0, _config.getGlobalRepo)());
            } else {
              repo = new _repository.Repository(_path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME), (0, _config.getGlobalRepo)());
            }

            bundle = _bundle.Bundle.from((0, _config.getRootBundlePath)(options.global));
            _context.next = 5;
            return bundle.update(repo, options.global);

          case 5:
            needUpdate = _context.sent;
            checkUpdateFunction(needUpdate, options.global, options.json);

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _checkUpdate.apply(this, arguments);
}

function checkUpdateFunction(needUpdate, isGlobal, withJSON) {
  var bundles = Object.keys(needUpdate).map(function (key) {
    var _needUpdate$key = needUpdate[key],
        local = _needUpdate$key.local,
        global = _needUpdate$key.global,
        remote = _needUpdate$key.remote;
    return {
      name: key,
      local: local === 'miss' ? 'miss' : "v".concat(local),
      global: !global || global === 'miss' ? global : "v".concat(global),
      remote: "v".concat(remote)
    };
  });

  if (bundles.length === 0) {
    _i18n["default"].log('update.noNeedUpdate');
  } else {
    var output = isGlobal ? ['name', 'global', 'remote'] : ['name', 'local', 'global', 'remote'];
    withJSON ? console.log(JSON.stringify(bundles)) : console.table(bundles, output);
  }
}