"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.config = void 0;

var _rcParser = _interopRequireDefault(require("../core/rc-parser"));

var _i18n = _interopRequireWildcard(require("../i18n"));

var _constant = require("../constant/constant");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var config = function config(options, args) {
  var actionName = args && args[0];

  var rcParser = _rcParser["default"].fromPath(_constant.DEFAULT_CONFIG_FILE);

  if (actionName === 'set') {
    if (args.length !== 3) {
      throw (0, _i18n.getI18nMessage)('config.setFormat');
    }

    var key = args[1];
    var value = args[2];
    rcParser.set(key, value);
    rcParser.save();
  } else if (actionName === 'delete') {
    if (args.length !== 2) {
      throw (0, _i18n.getI18nMessage)('config.deleteFormat');
    }

    var _key = args[1];
    rcParser["delete"](_key);
    rcParser.save();
  }

  if (options.json) {
    console.log(JSON.stringify(rcParser.toJson(), null, 4));
  } else {
    _i18n["default"].log('common.message', {
      message: "".concat(rcParser.toString(), "\n")
    });

    _i18n["default"].log('common.modifyRc', {
      filePath: _constant.DEFAULT_CONFIG_FILE
    });
  }
};

exports.config = config;