"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.distribute = distribute;
exports.bundleDist = bundleDist;
exports.getValidDistCmd = getValidDistCmd;

var _path = _interopRequireDefault(require("path"));

var _bundle = require("../core/bundle");

var _repository = require("../core/repository");

var _build = require("./build");

var _constant = require("../constant/constant");

var _helpers = require("../utils/helpers");

var _config = require("../utils/config");

var _i18n = _interopRequireWildcard(require("../i18n"));

var _events = _interopRequireWildcard(require("../utils/events"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function distribute(_x, _x2) {
  return _distribute.apply(this, arguments);
}

function _distribute() {
  _distribute = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(commanderObj, customizeArgs) {
    var startBundle, repo;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            startBundle = _bundle.Bundle.from(process.cwd());
            repo = new _repository.Repository(_path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME), (0, _config.getGlobalRepo)());
            _context.next = 4;
            return bundleDist(startBundle, repo, customizeArgs);

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _distribute.apply(this, arguments);
}

function bundleDist(_x3, _x4, _x5) {
  return _bundleDist.apply(this, arguments);
}

function _bundleDist() {
  _bundleDist = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(startBundle, repo, customizeArgs) {
    var bundles, _iterator, _step, bundle, distChain;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return startBundle.build(repo);

          case 2:
            bundles = _context2.sent;
            _iterator = _createForOfIteratorHelper(bundles);

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                bundle = _step.value;

                if (!bundle.isPublishAs('distribution')) {
                  (0, _build.bundleBuild)(bundle, bundle.id === startBundle.id);
                }
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }

            distChain = bundles.filter(function (b) {
              return b.isPublishAs('distribution');
            }).reverse();

            if (!(distChain.length <= 0)) {
              _context2.next = 8;
              break;
            }

            throw (0, _i18n.getI18nMessage)('dist.miss', {
              name: startBundle.manifest.name
            });

          case 8:
            _context2.next = 10;
            return runDistCmd(distChain, customizeArgs);

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _bundleDist.apply(this, arguments);
}

function runDistCmd(_x6, _x7) {
  return _runDistCmd.apply(this, arguments);
}

function _runDistCmd() {
  _runDistCmd = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(distChain, customizeArgs) {
    var startBundle, distBundle, distCmd, preDistCmd, afterDistCmd;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            startBundle = distChain[0];
            distBundle = distChain.find(function (cBundle) {
              return cBundle.scripts('dist');
            });
            distCmd = getValidDistCmd(distBundle);
            preDistCmd = distBundle.scripts(_constant.Hooks.preDist);

            if (preDistCmd) {
              (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
                return spawnSync(preDistCmd, {
                  shell: process.env.shellPath,
                  env: startBundle.vars.env,
                  cwd: distBundle.path,
                  stdio: 'inherit'
                });
              });
            }

            _events["default"].emit('hooks', {
              type: _events.EventTypes.beforeDist,
              name: distBundle.name,
              path: distBundle.path
            });

            _i18n["default"].log('dist.building', {
              name: distBundle.manifest.name
            });

            if (customizeArgs && customizeArgs.length > 0) {
              distCmd = "".concat(distCmd, " ").concat(customizeArgs.join(" "));
            }

            (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
              return spawnSync(distCmd, {
                cwd: distBundle.path,
                env: startBundle.vars.env,
                shell: process.env.shellPath,
                stdio: 'inherit'
              });
            });

            if (!process.exitCode) {
              _i18n["default"].log('dist.complete', {
                name: distBundle.manifest.name
              });

              afterDistCmd = distBundle.scripts(_constant.Hooks.afterDist);

              if (afterDistCmd) {
                (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
                  return spawnSync(afterDistCmd, {
                    shell: process.env.shellPath,
                    env: startBundle.vars.env,
                    cwd: distBundle.path,
                    stdio: 'inherit'
                  });
                });
              }

              _events["default"].emit('hooks', {
                type: _events.EventTypes.afterDist,
                name: distBundle.name,
                path: distBundle.path
              });
            }

          case 10:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _runDistCmd.apply(this, arguments);
}

function getValidDistCmd(distBundle) {
  if (!distBundle) {
    throw (0, _i18n.getI18nMessage)('dist.needScripts');
  }

  var distCmd = distBundle.scripts('dist');

  if (typeof distCmd !== 'string') {
    throw (0, _i18n.getI18nMessage)('dist.shouldBeCommand', {
      name: distBundle.manifest.name
    });
  }

  return distCmd;
}