"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.extract = extract;

var _i18n = _interopRequireWildcard(require("../i18n"));

var _log = _interopRequireDefault(require("../core/log"));

var _helpers = require("../utils/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var pump = require("pump");

var mkdirp = require("mkdirp");

var C = require('compressing');

var path = require('path');

var fs = require('fs');

function getPackType(ext, fileName) {
  switch (ext) {
    case '.zip':
      return 'zip';

    case '.tar':
      return 'tar';

    case '.tgz':
      return 'tgz';

    default:
      if (fileName.endsWith('.tar.gz')) {
        return 'tgz';
      }

      throw (0, _i18n.getI18nMessage)('extract.unsupport');
  }
}

function extract(_x, _x2) {
  return _extract.apply(this, arguments);
} //compressing解压时symlink解压错误。重写该方法修复解压问题


function _extract() {
  _extract = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(source, target) {
    var _ref,
        _ref$silent,
        silent,
        filePathInfo,
        handleType,
        x,
        _args = arguments;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _ref = _args.length > 2 && _args[2] !== undefined ? _args[2] : {}, _ref$silent = _ref.silent, silent = _ref$silent === void 0 ? false : _ref$silent;

            _i18n["default"].log('extract.running', {
              source: source
            }, {
              silent: silent
            });

            filePathInfo = path.parse(source);
            handleType = getPackType(filePathInfo.ext, source);
            C[handleType].uncompress = uncompressOverwrite(C[handleType].UncompressStream);
            _context.next = 7;
            return C[handleType].uncompress(path.resolve(source), path.resolve(target || process.cwd()));

          case 7:
            x = _context.sent;

            _i18n["default"].log('extract.success', null, {
              silent: silent
            });

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _extract.apply(this, arguments);
}

function uncompressOverwrite(StreamClass) {
  return function (source, destDir, opts) {
    opts = opts || {};
    opts.source = source;
    return new Promise(function (resolve, reject) {
      (0, _helpers.runShellCmd)(function (shell) {
        return shell.mkdir('-p', destDir);
      });
      var entryCount = 0;
      var successCount = 0;
      var isFinish = false;

      function done() {
        // resolve when both stream finish and file write finish
        if (isFinish && entryCount === successCount) resolve();
      }

      new StreamClass(opts).on('finish', function () {
        isFinish = true;
        done();
      }).on('error', reject).on('entry', function (header, stream, next) {
        stream.on('end', next);

        if (header.type === 'file') {
          var fullpath = path.join(destDir, header.name);
          (0, _helpers.runShellCmd)(function (shell) {
            return shell.mkdir('-p', path.dirname(fullpath));
          });
          entryCount++;
          pump(stream, fs.createWriteStream(fullpath, {
            mode: header.mode
          }), function (err) {
            if (err) return reject(err);
            successCount++;
            done();
          });
        } else if (header.type === 'symlink') {
          var src = path.join(destDir, header.name);

          try {
            if (fs.existsSync(src)) {
              (0, _helpers.runShellCmd)(function (shell) {
                return shell.rm("-r", src);
              });
            } else {
              var stat = fs.lstatSync(src);

              if (stat.isSymbolicLink()) {
                fs.unlinkSync(src);
              }
            }
          } catch (_unused) {}

          fs.symlinkSync(header.linkname, src);
          stream.resume();
        } else {
          // directory
          (0, _helpers.runShellCmd)(function (shell) {
            return shell.mkdir('-p', path.join(destDir, header.name));
          });
          stream.resume();
        }
      });
    });
  };
}