"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runAction = runAction;
exports.defaultCmdConfigs = void 0;

var _manifest = require("../core/manifest");

var _i18n = require("../i18n");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function runAction(_x, _x2, _x3) {
  return _runAction.apply(this, arguments);
}

function _runAction() {
  _runAction = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(name, args, pluginAPI) {
    var commandsPath, _require, init, _require2, build, _require3, pack, _require4, distribute, _require5, install, _require6, uninstall, _require7, publish, _require8, run, _require9, config, _require10, search, _require11, update, _require12, checkUpdate, _require13, list, _require14, generateKeys, _require15, extract, _require16, ui, _require17, lang;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            commandsPath = '.';
            _context.t0 = name;
            _context.next = _context.t0 === 'init' ? 4 : _context.t0 === 'build' ? 8 : _context.t0 === 'pack' ? 12 : _context.t0 === 'dist' ? 16 : _context.t0 === 'install' ? 20 : _context.t0 === 'uninstall' ? 24 : _context.t0 === 'publish' ? 28 : _context.t0 === 'run' ? 32 : _context.t0 === 'config' ? 36 : _context.t0 === 'search' ? 40 : _context.t0 === 'update' ? 44 : _context.t0 === 'check-update' ? 48 : _context.t0 === 'list' ? 52 : _context.t0 === 'gen-keys' ? 56 : _context.t0 === 'extract' ? 60 : _context.t0 === 'ui' ? 64 : _context.t0 === 'lang' ? 68 : 72;
            break;

          case 4:
            _require = require("".concat(commandsPath, "/init")), init = _require.init;
            _context.next = 7;
            return init.apply(void 0, _toConsumableArray(args));

          case 7:
            return _context.abrupt("return", _context.sent);

          case 8:
            _require2 = require("".concat(commandsPath, "/build")), build = _require2.build;
            _context.next = 11;
            return build.apply(void 0, _toConsumableArray(args));

          case 11:
            return _context.abrupt("return", _context.sent);

          case 12:
            _require3 = require("".concat(commandsPath, "/pack")), pack = _require3.pack;
            _context.next = 15;
            return pack.apply(void 0, _toConsumableArray(args));

          case 15:
            return _context.abrupt("return", _context.sent);

          case 16:
            _require4 = require("".concat(commandsPath, "/distribute")), distribute = _require4.distribute;
            _context.next = 19;
            return distribute.apply(void 0, _toConsumableArray(args));

          case 19:
            return _context.abrupt("return", _context.sent);

          case 20:
            _require5 = require("".concat(commandsPath, "/install")), install = _require5.install;
            _context.next = 23;
            return install.apply(void 0, _toConsumableArray(args));

          case 23:
            return _context.abrupt("return", _context.sent);

          case 24:
            _require6 = require("".concat(commandsPath, "/uninstall")), uninstall = _require6.uninstall;
            _context.next = 27;
            return uninstall.apply(void 0, _toConsumableArray(args));

          case 27:
            return _context.abrupt("return", _context.sent);

          case 28:
            _require7 = require("".concat(commandsPath, "/publish")), publish = _require7.publish;
            _context.next = 31;
            return publish.apply(void 0, _toConsumableArray(args));

          case 31:
            return _context.abrupt("return", _context.sent);

          case 32:
            _require8 = require("".concat(commandsPath, "/run")), run = _require8.run;
            _context.next = 35;
            return run.apply(void 0, _toConsumableArray(args));

          case 35:
            return _context.abrupt("return", _context.sent);

          case 36:
            _require9 = require("".concat(commandsPath, "/config")), config = _require9.config;
            _context.next = 39;
            return config.apply(void 0, _toConsumableArray(args));

          case 39:
            return _context.abrupt("return", _context.sent);

          case 40:
            _require10 = require("".concat(commandsPath, "/search")), search = _require10.search;
            _context.next = 43;
            return search.apply(void 0, _toConsumableArray(args));

          case 43:
            return _context.abrupt("return", _context.sent);

          case 44:
            _require11 = require("".concat(commandsPath, "/update")), update = _require11.update;
            _context.next = 47;
            return update.apply(void 0, _toConsumableArray(args));

          case 47:
            return _context.abrupt("return", _context.sent);

          case 48:
            _require12 = require("".concat(commandsPath, "/checkUpdate")), checkUpdate = _require12.checkUpdate;
            _context.next = 51;
            return checkUpdate.apply(void 0, _toConsumableArray(args));

          case 51:
            return _context.abrupt("return", _context.sent);

          case 52:
            _require13 = require("".concat(commandsPath, "/list")), list = _require13.list;
            _context.next = 55;
            return list.apply(void 0, _toConsumableArray(args));

          case 55:
            return _context.abrupt("return", _context.sent);

          case 56:
            _require14 = require("".concat(commandsPath, "/generateKeys")), generateKeys = _require14.generateKeys;
            _context.next = 59;
            return generateKeys.apply(void 0, _toConsumableArray(args));

          case 59:
            return _context.abrupt("return", _context.sent);

          case 60:
            _require15 = require("".concat(commandsPath, "/extract")), extract = _require15.extract;
            _context.next = 63;
            return extract.apply(void 0, _toConsumableArray(args));

          case 63:
            return _context.abrupt("return", _context.sent);

          case 64:
            _require16 = require("".concat(commandsPath, "/ui")), ui = _require16.ui;
            _context.next = 67;
            return ui.apply(void 0, [pluginAPI].concat(_toConsumableArray(args)));

          case 67:
            return _context.abrupt("return", _context.sent);

          case 68:
            _require17 = require("".concat(commandsPath, "/lang")), lang = _require17.lang;
            _context.next = 71;
            return lang.apply(void 0, _toConsumableArray(args));

          case 71:
            return _context.abrupt("return", _context.sent);

          case 72:
            return _context.abrupt("return");

          case 73:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _runAction.apply(this, arguments);
}

var defaultCmdConfigs = [{
  name: 'dist',
  description: (0, _i18n.getI18nMessage)('help.dist'),
  allowUnknownOption: true,
  allowBundleTypes: ['dist'],
  isBundleDefaultCmd: function isBundleDefaultCmd(publishAs) {
    return publishAs === 'distribution' && _manifest.Manifest.Validator.publishAs(publishAs);
  }
}, {
  name: 'build',
  description: (0, _i18n.getI18nMessage)('help.build'),
  allowUnknownOption: true,
  allowBundleTypes: ['source'],
  isBundleDefaultCmd: function isBundleDefaultCmd(publishAs) {
    return publishAs === 'source' && _manifest.Manifest.Validator.publishAs(publishAs);
  }
}, {
  name: 'pack',
  description: (0, _i18n.getI18nMessage)('help.pack'),
  allowUnknownOption: false,
  isBundleDefaultCmd: _manifest.Manifest.Validator.publishAs
}, {
  name: 'publish',
  description: (0, _i18n.getI18nMessage)('help.publish'),
  options: {
    '-o, --old': (0, _i18n.getI18nMessage)('help.publishOld')
  },
  allowUnknownOption: false,
  isBundleDefaultCmd: _manifest.Manifest.Validator.publishAs
}, {
  name: 'list',
  alias: 'ls',
  description: (0, _i18n.getI18nMessage)('help.list'),
  options: {
    '-j, --json': (0, _i18n.getI18nMessage)('help.searchJson'),
    '-g, --global': (0, _i18n.getI18nMessage)('help.listGlobal')
  },
  allowUnknownOption: false,
  isBundleDefaultCmd: function isBundleDefaultCmd(publishAs) {
    return _manifest.Manifest.Validator.publishAs(publishAs) && publishAs !== 'plugin';
  }
}];
exports.defaultCmdConfigs = defaultCmdConfigs;