"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.init = init;

var _inquirer = require("inquirer");

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _manifest = require("../core/manifest");

var _template = require("../core/template");

var _helpers = require("../utils/helpers");

var _i18n = _interopRequireDefault(require("../i18n"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function init(_x) {
  return _init.apply(this, arguments);
}

function _init() {
  _init = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(name) {
    var options,
        manifestJson,
        dirname,
        input,
        _yield$parseTemplate,
        templateJson,
        inputJson,
        _args = arguments;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
            manifestJson = {};
            dirname = options.dirname ? _path["default"].resolve(options.dirname) : process.cwd();
            (0, _helpers.runShellCmd)(function (shell) {
              return shell.mkdir('-p', dirname);
            });

            _i18n["default"].log('init.create', {
              dirname: dirname
            });

            input = [{
              type: 'input',
              name: 'name',
              message: 'bundle name',
              validate: _manifest.Manifest.Validator.name
            }, {
              type: 'input',
              name: 'version',
              message: 'version',
              validate: _manifest.Manifest.Validator.version
            }];

            if (name) {
              manifestJson.name = name;
              manifestJson.version = '1.0.0';
            }

            if (!options.template) {
              _context.next = 13;
              break;
            }

            _context.next = 10;
            return (0, _template.parseTemplate)(options.template, dirname);

          case 10:
            _yield$parseTemplate = _context.sent;
            templateJson = _yield$parseTemplate.manifestJson;
            manifestJson = _objectSpread(_objectSpread({}, templateJson), manifestJson);

          case 13:
            if (!(!name && !options.template)) {
              _context.next = 18;
              break;
            }

            _context.next = 16;
            return (0, _inquirer.prompt)(input);

          case 16:
            inputJson = _context.sent;
            manifestJson = _objectSpread(_objectSpread({}, manifestJson), inputJson);

          case 18:
            if (options.scope) {
              manifestJson.name = (0, _helpers.getScopeName)(manifestJson.name, options.scope);
            }

            _manifest.Manifest.json(manifestJson); // Validate manifest json


            _fs["default"].writeFileSync(_path["default"].join(dirname, 'bundle.json'), JSON.stringify(manifestJson, null, '  '));

            _i18n["default"].log('init.finished');

          case 22:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _init.apply(this, arguments);
}