"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.install = install;
exports.installBundle = installBundle;
exports.parseInstallParam = parseInstallParam;
exports.traverseDownload = traverseDownload;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _os = _interopRequireDefault(require("os"));

var _semver = _interopRequireDefault(require("semver"));

var _repository = require("../core/repository");

var _bundle = require("../core/bundle");

var _i18n = _interopRequireWildcard(require("../i18n"));

var _constant = require("../constant/constant");

var _manifest = require("../core/manifest");

var _dependency = require("../core/dependency");

var _tools = require("../thread/tools");

var _config = require("../utils/config");

var _helpers = require("../utils/helpers");

var _pack = require("./pack");

var _variable = require("../core/variable");

var _extract = require("./extract");

var _events = _interopRequireWildcard(require("../utils/events"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _require = require('worker_threads'),
    Worker = _require.Worker;
/**
 * 组件安装的入口函数
 *
 * @param {String} bundleDescriptor 组件描述，可以用','分割
 * @param {object} options 参数，有global、saveDev
 */


function install(_x) {
  return _install.apply(this, arguments);
}

function _install() {
  _install = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(bundleDescriptor) {
    var options,
        repo,
        installPath,
        bundle,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
            repo = null;

            if (!((options.global || options.saveDev) && !bundleDescriptor)) {
              _context.next = 4;
              break;
            }

            throw (0, _i18n.getI18nMessage)('install.nameIsRequired');

          case 4:
            if (options.global) {
              repo = new _repository.Repository('', (0, _config.getGlobalRepo)());
            } else {
              repo = new _repository.Repository(_path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME));
            }

            installPath = (0, _config.getRootBundlePath)(options.global);
            bundle = _bundle.Bundle.from(installPath);
            (0, _repository.createDirIfNotExists)(_constant.DEP_FOLDER_NAME, installPath);
            _context.next = 10;
            return installBundle(bundle, repo, bundleDescriptor, {
              isGlobal: options.global,
              type: options.saveDev ? 'dev' : ''
            });

          case 10:
            _i18n["default"].log('install.success');

          case 11:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _install.apply(this, arguments);
}

function installBundle(_x2, _x3, _x4) {
  return _installBundle.apply(this, arguments);
}

function _installBundle() {
  _installBundle = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(bundle, repo, bundleDescriptor) {
    var _ref,
        isGlobal,
        type,
        dependencies,
        installPath,
        manifests,
        installedManifests,
        _args2 = arguments;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _ref = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : {}, isGlobal = _ref.isGlobal, type = _ref.type;
            dependencies = null;
            installPath = isGlobal ? process.env.globalRepo : process.cwd();

            if (!bundleDescriptor) {
              _context2.next = 8;
              break;
            }

            _context2.next = 6;
            return parseInstallParam(bundleDescriptor, repo);

          case 6:
            dependencies = _context2.sent;
            bundle.addDependencies(dependencies, type);

          case 8:
            _events["default"].emit('hooks', {
              type: _events.EventTypes.beforeAllInstall
            });

            _context2.next = 11;
            return bundle.install(repo, isGlobal);

          case 11:
            manifests = _context2.sent;
            _context2.next = 14;
            return traverseDownload(manifests, isGlobal);

          case 14:
            installedManifests = _context2.sent;
            installedManifests.forEach(function (m) {
              var dirPath = m.path;

              var localManifest = _manifest.Manifest.fromPath(dirPath);

              var installCmd = localManifest.scripts(_constant.Hooks.install) || localManifest.scripts(_constant.Hooks.afterInstall);

              if (installCmd) {
                (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
                  return spawnSync(installCmd, {
                    shell: process.env.shellPath,
                    env: _variable.Variable.basicEnv(installPath),
                    cwd: dirPath,
                    stdio: 'inherit'
                  });
                });
              }

              _events["default"].emit('hooks', {
                type: _events.EventTypes.afterEachInstall,
                name: m.name,
                path: dirPath
              });
            });

            if (dependencies && dependencies.length > 0) {
              bundle.updateDependencies(dependencies, type);
              bundle.updateBundleJson();
            }

            _events["default"].emit('hooks', {
              type: _events.EventTypes.afterAllInstall
            });

          case 18:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _installBundle.apply(this, arguments);
}

function parseInstallParam(_x5, _x6) {
  return _parseInstallParam.apply(this, arguments);
}

function _parseInstallParam() {
  _parseInstallParam = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(bundleDescriptor, repo) {
    var list, dependencies, getDependency, _iterator, _step, nameVersion, dep;

    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            list = String(bundleDescriptor).split(',');
            dependencies = [];

            getDependency = /*#__PURE__*/function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(nameVersion) {
                var trimed, filePath, bundle, dependency, index, version, name;
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        trimed = nameVersion.trim();
                        filePath = checkDependencyPath(trimed);

                        if (!filePath) {
                          _context3.next = 8;
                          break;
                        }

                        _context3.next = 5;
                        return copyBundleToRepo(filePath, repo);

                      case 5:
                        bundle = _context3.sent;
                        dependency = new _dependency.Dependency(bundle.manifest.name, bundle.manifest.version.version);
                        return _context3.abrupt("return", dependency);

                      case 8:
                        if (!(!filePath && !trimed.startsWith('@'))) {
                          _context3.next = 10;
                          break;
                        }

                        throw (0, _i18n.getI18nMessage)("install.pathError", {
                          name: trimed
                        });

                      case 10:
                        index = trimed.lastIndexOf('@');
                        version = (index > 0 ? trimed.substr(index + 1) : '') || '*'; // index === 0 is scoped name

                        name = index > 0 ? trimed.substr(0, index).trim() : trimed;

                        if (!(_manifest.Manifest.Validator.name(name) !== true)) {
                          _context3.next = 15;
                          break;
                        }

                        throw (0, _i18n.getI18nMessage)('install.validator', {
                          name: name,
                          validateMessage: _manifest.Manifest.Validator.name(name)
                        });

                      case 15:
                        if (_semver["default"].validRange(version)) {
                          _context3.next = 17;
                          break;
                        }

                        throw (0, _i18n.getI18nMessage)('install.invalidVersionRange', {
                          name: name
                        });

                      case 17:
                        return _context3.abrupt("return", new _dependency.Dependency(name, version));

                      case 18:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function getDependency(_x9) {
                return _ref2.apply(this, arguments);
              };
            }();

            _iterator = _createForOfIteratorHelper(list);
            _context4.prev = 4;

            _iterator.s();

          case 6:
            if ((_step = _iterator.n()).done) {
              _context4.next = 14;
              break;
            }

            nameVersion = _step.value;
            _context4.next = 10;
            return getDependency(nameVersion);

          case 10:
            dep = _context4.sent;
            dependencies.push(dep);

          case 12:
            _context4.next = 6;
            break;

          case 14:
            _context4.next = 19;
            break;

          case 16:
            _context4.prev = 16;
            _context4.t0 = _context4["catch"](4);

            _iterator.e(_context4.t0);

          case 19:
            _context4.prev = 19;

            _iterator.f();

            return _context4.finish(19);

          case 22:
            return _context4.abrupt("return", dependencies);

          case 23:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, null, [[4, 16, 19, 22]]);
  }));
  return _parseInstallParam.apply(this, arguments);
}

function traverseDownload(manifests, isGlobal) {
  return new Promise(function (resolve, reject) {
    var needDownload = [].concat(manifests).filter(function (manifest) {
      return !!manifest.url;
    });

    if (needDownload.length === 0) {
      resolve([]);
      return;
    }

    var threadEntryFile = _path["default"].join(__dirname, '..', 'thread', 'installEntry.js');

    var downloadCnt = 0;
    var allWorker = [];
    needDownload.forEach(function (manifest) {
      _i18n["default"].log('install.downloading', {
        name: manifest.name
      });

      var worker = new Worker(threadEntryFile, {
        workerData: {
          manifest: manifest.json(true),
          // 不可以直接传整个manifest进去，因为没法clone给子对象
          isGlobal: isGlobal
        }
      });
      worker.on('exit', function (errCode) {
        if (errCode === 0) {
          if (++downloadCnt === needDownload.length) {
            resolve(needDownload);
          }
        } else {
          (0, _tools.closeAllThread)(allWorker);
          reject((0, _i18n.getI18nMessage)('error.workerStop', {
            errCode: errCode
          }));
        }
      });
      worker.on('message', function (manifestPath) {
        manifests.forEach(function (m) {
          if (m.name === manifest.name) {
            m.path = manifestPath;
          }
        });
      });
      allWorker.push(worker);
    });
  });
}

function checkDependencyPath(filePath) {
  if (_fs["default"].existsSync(_path["default"].resolve(filePath))) {
    return filePath;
  }

  return '';
}

function copyBundleToRepo(_x7, _x8) {
  return _copyBundleToRepo.apply(this, arguments);
}

function _copyBundleToRepo() {
  _copyBundleToRepo = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(filePath, repo) {
    var newTmpDir, resolvedPath, bundle, manifest, fileName, nameInfo, repoPath, dirPath, preInstallCmd, installCmd;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            resolvedPath = _path["default"].resolve(filePath);

            if (!_fs["default"].lstatSync(resolvedPath).isFile()) {
              _context5.next = 8;
              break;
            }

            newTmpDir = _path["default"].join(_os["default"].tmpdir(), "dependency-".concat(Date.now()));
            (0, _helpers.runShellCmd)(function (shell) {
              return shell.mkdir('-p', newTmpDir);
            });
            _context5.next = 6;
            return (0, _extract.extract)(resolvedPath, newTmpDir, {
              silent: true
            });

          case 6:
            _context5.next = 9;
            break;

          case 8:
            newTmpDir = resolvedPath;

          case 9:
            bundle = _bundle.Bundle.from(newTmpDir);
            manifest = bundle.manifest;

            _i18n["default"].log('install.installingTar', {
              name: manifest.name
            });

            (0, _pack.packBundle)(bundle, {
              silent: true
            });
            fileName = "".concat(bundle.id, ".tgz");
            nameInfo = (0, _helpers.parseScopeName)(manifest.name);
            repoPath = repo.path || repo.globalRepoPath;
            dirPath = _path["default"].resolve(_path["default"].join(repoPath, nameInfo.scope, nameInfo.name));
            (0, _repository.createDirIfNotExists)(dirPath);
            preInstallCmd = manifest.scripts(_constant.Hooks.preInstall);

            if (preInstallCmd) {
              (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
                return spawnSync(preInstallCmd, {
                  shell: process.env.shellPath,
                  env: _variable.Variable.basicEnv(repoPath),
                  cwd: dirPath,
                  stdio: 'inherit'
                });
              });
            }

            _events["default"].emit('hooks', {
              type: _events.EventTypes.beforeAllInstall,
              name: manifest.name
            });

            _events["default"].emit('hooks', {
              type: _events.EventTypes.beforeEachInstall,
              name: manifest.name
            });

            _context5.next = 24;
            return (0, _extract.extract)(fileName, dirPath, {
              silent: true
            });

          case 24:
            (0, _helpers.runShellCmd)(function (shell) {
              return shell.rm('-rf', fileName);
            });
            installCmd = manifest.scripts('install') || manifest.scripts(_constant.Hooks.afterInstall);

            if (installCmd) {
              (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
                return spawnSync(installCmd, {
                  shell: process.env.shellPath,
                  env: _variable.Variable.basicEnv(repoPath),
                  cwd: dirPath,
                  stdio: 'inherit'
                });
              });
            }

            _events["default"].emit('hooks', {
              type: _events.EventTypes.afterEachInstall,
              name: manifest.name,
              path: dirPath
            });

            _events["default"].emit('hooks', {
              type: _events.EventTypes.afterAllInstall,
              name: manifest.name,
              path: dirPath
            });

            _i18n["default"].log('install.installTarFinished', {
              name: manifest.name
            });

            return _context5.abrupt("return", bundle);

          case 31:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _copyBundleToRepo.apply(this, arguments);
}