"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.lang = lang;
exports.langValidate = void 0;

var _inquirer = require("inquirer");

var _preference = _interopRequireDefault(require("../core/preference"));

var _i18n = require("../i18n");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var supportLanguages = (0, _i18n.getSupportLang)();

var langValidate = function langValidate(value) {
  return supportLanguages.includes(value);
};

exports.langValidate = langValidate;

function lang(_x) {
  return _lang.apply(this, arguments);
}

function _lang() {
  _lang = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(lang) {
    var result;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            result = lang;

            if (result) {
              _context.next = 5;
              break;
            }

            console.log((0, _i18n.getI18nMessage)('lang.current', {
              lang: _preference["default"].get('lang') || "en",
              supportLanguages: supportLanguages.join('|')
            }));
            _context.next = 11;
            break;

          case 5:
            if (!langValidate(result)) {
              _context.next = 10;
              break;
            }

            _preference["default"].set('lang', result, true);

            console.log((0, _i18n.getI18nMessage)('lang.success', {
              lang: result
            }));
            _context.next = 11;
            break;

          case 10:
            throw (0, _i18n.getI18nMessage)('lang.supportError', {
              supportLanguages: supportLanguages.join('|')
            });

          case 11:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _lang.apply(this, arguments);
}