"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.run = run;
exports.runCmd = runCmd;

var _path = _interopRequireDefault(require("path"));

var _bundle = require("../core/bundle");

var _helpers = require("../utils/helpers");

var _build = require("./build");

var _distribute = require("./distribute");

var _repository = require("../core/repository");

var _constant = require("../constant/constant");

var _variable = require("../core/variable");

var _config = require("../utils/config");

var _i18n = require("../i18n");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function run(_x, _x2, _x3) {
  return _run.apply(this, arguments);
}

function _run() {
  _run = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(name, commanderObj, customizeArgs) {
    var bundle, repo;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            bundle = _variable.Variable.compute([_bundle.Bundle.from(process.cwd())])[0];
            repo = new _repository.Repository(_path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME), (0, _config.getGlobalRepo)());
            _context.next = 4;
            return runCmd(bundle, repo, name, true, customizeArgs);

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _run.apply(this, arguments);
}

function runCmd(_x4, _x5, _x6) {
  return _runCmd.apply(this, arguments);
}

function _runCmd() {
  _runCmd = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(bundle, repo, name) {
    var useMultipleThread,
        customizeArgs,
        cmd,
        _args2 = arguments;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            useMultipleThread = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : true;
            customizeArgs = _args2.length > 4 ? _args2[4] : undefined;
            cmd = bundle.scripts(name);

            if (cmd) {
              _context2.next = 5;
              break;
            }

            throw (0, _i18n.getI18nMessage)('run.noCommand', {
              name: name
            });

          case 5:
            if (customizeArgs && customizeArgs.length > 0) {
              cmd = "".concat(cmd, " ").concat(customizeArgs.join(' '));
            }

            if (!(name === 'build')) {
              _context2.next = 11;
              break;
            }

            _context2.next = 9;
            return (0, _build.startBuild)(bundle, repo, useMultipleThread, customizeArgs);

          case 9:
            _context2.next = 17;
            break;

          case 11:
            if (!(name === 'dist')) {
              _context2.next = 16;
              break;
            }

            _context2.next = 14;
            return (0, _distribute.bundleDist)(bundle, repo, customizeArgs);

          case 14:
            _context2.next = 17;
            break;

          case 16:
            (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
              return spawnSync(cmd, {
                shell: process.env.shellPath,
                env: bundle.vars.env,
                stdio: 'inherit'
              });
            });

          case 17:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _runCmd.apply(this, arguments);
}