"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.search = search;
exports.renderData = exports.renderInfo = exports.pageSearch = exports.query = void 0;

var _inquirer = require("inquirer");

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _semver = _interopRequireDefault(require("semver"));

var _axios = require("../utils/axios");

var _helpers = require("../utils/helpers");

var _i18n = _interopRequireWildcard(require("../i18n"));

var _log = _interopRequireDefault(require("../core/log"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function search(_x, _x2) {
  return _search.apply(this, arguments);
}

function _search() {
  _search = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(searchKey, _ref) {
    var _ref$pageSize, pageSize, withJson, type, _ref$currentPage, currentPage, ver, matchBy, currentPageNum, pageSizeNum, params;

    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _ref$pageSize = _ref.pageSize, pageSize = _ref$pageSize === void 0 ? 10 : _ref$pageSize, withJson = _ref.json, type = _ref.type, _ref$currentPage = _ref.currentPage, currentPage = _ref$currentPage === void 0 ? 1 : _ref$currentPage, ver = _ref.version;
            matchBy = [];

            if (searchKey) {
              matchBy.push({
                field: 'name',
                opt: 'CONTAIN',
                value: searchKey
              });
            }

            if (type) {
              matchBy.push({
                field: 'publishAs',
                opt: 'EQUAL',
                value: type
              });
            }

            if (ver && (ver === 'latest' || ver === 'all' || _semver["default"].validRange(ver))) {
              matchBy.push({
                field: 'version',
                opt: 'EQUAL',
                value: ver
              });
            }

            currentPageNum = Number(currentPage);
            pageSizeNum = Number(pageSize);
            params = {
              pageSize: pageSizeNum,
              condition: JSON.stringify({
                matchBy: matchBy
              }),
              currentPage: currentPageNum
            };
            _context4.next = 10;
            return pageSearch({
              query: query,
              searchKey: searchKey,
              condition: params.condition,
              currentPage: currentPageNum,
              totalPage: Infinity,
              pageSize: pageSizeNum,
              withJson: withJson,
              type: type
            });

          case 10:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _search.apply(this, arguments);
}

var query = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(searchKey, params) {
    var _yield$axios$get, data;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _axios.axios.get(_helpers.URL.search(searchKey), {
              params: params
            });

          case 2:
            _yield$axios$get = _context.sent;
            data = _yield$axios$get.data.data;
            return _context.abrupt("return", {
              data: data.datas,
              totalSize: data.total
            });

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function query(_x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}();

exports.query = query;

var pageSearch = /*#__PURE__*/function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref3) {
    var query, searchKey, condition, currentPage, totalPage, pageSize, withJson, type, nextTotalPage, _yield$query, data, totalSize, doUserAction;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            query = _ref3.query, searchKey = _ref3.searchKey, condition = _ref3.condition, currentPage = _ref3.currentPage, totalPage = _ref3.totalPage, pageSize = _ref3.pageSize, withJson = _ref3.withJson, type = _ref3.type;
            nextTotalPage = totalPage;

            if (!(currentPage <= nextTotalPage)) {
              _context3.next = 11;
              break;
            }

            _context3.next = 5;
            return query(searchKey, {
              pageSize: pageSize,
              condition: condition,
              curPage: currentPage
            });

          case 5:
            _yield$query = _context3.sent;
            data = _yield$query.data;
            totalSize = _yield$query.totalSize;
            addDefaultTemplateIntoData(data, currentPage, type);
            renderData(data, searchKey, withJson);
            nextTotalPage = Math.ceil(totalSize / pageSize);

          case 11:
            doUserAction = /*#__PURE__*/function () {
              var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                var _yield$prompt, userAction;

                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return (0, _inquirer.prompt)([{
                          type: 'input',
                          message: "".concat(renderInfo(currentPage, nextTotalPage)),
                          name: 'userAction'
                        }]);

                      case 2:
                        _yield$prompt = _context2.sent;
                        userAction = _yield$prompt.userAction;
                        _context2.t0 = userAction;
                        _context2.next = _context2.t0 === 'n' ? 7 : _context2.t0 === 'p' ? 16 : _context2.t0 === 'q' ? 25 : 27;
                        break;

                      case 7:
                        if (!(currentPage > nextTotalPage)) {
                          _context2.next = 13;
                          break;
                        }

                        _i18n["default"].log('search.noMoreResult');

                        _context2.next = 11;
                        return doUserAction();

                      case 11:
                        _context2.next = 15;
                        break;

                      case 13:
                        _context2.next = 15;
                        return pageSearch({
                          query: query,
                          searchKey: searchKey,
                          condition: condition,
                          currentPage: Math.max(1, Math.min(currentPage + 1, nextTotalPage + 1)),
                          totalPage: nextTotalPage,
                          pageSize: pageSize,
                          type: type
                        });

                      case 15:
                        return _context2.abrupt("break", 30);

                      case 16:
                        if (!(currentPage === 1)) {
                          _context2.next = 22;
                          break;
                        }

                        _i18n["default"].log('search.onFirstPage');

                        _context2.next = 20;
                        return doUserAction();

                      case 20:
                        _context2.next = 24;
                        break;

                      case 22:
                        _context2.next = 24;
                        return pageSearch({
                          query: query,
                          searchKey: searchKey,
                          condition: condition,
                          currentPage: Math.max(1, Math.min(currentPage - 1, nextTotalPage)),
                          totalPage: nextTotalPage,
                          pageSize: pageSize,
                          type: type
                        });

                      case 24:
                        return _context2.abrupt("break", 30);

                      case 25:
                        _i18n["default"].log('search.quit');

                        return _context2.abrupt("return");

                      case 27:
                        _context2.next = 29;
                        return doUserAction();

                      case 29:
                        return _context2.abrupt("break", 30);

                      case 30:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function doUserAction() {
                return _ref5.apply(this, arguments);
              };
            }();

            if (withJson) {
              _context3.next = 15;
              break;
            }

            _context3.next = 15;
            return doUserAction();

          case 15:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function pageSearch(_x5) {
    return _ref4.apply(this, arguments);
  };
}();

exports.pageSearch = pageSearch;

var renderInfo = function renderInfo(currentPage, totalPage) {
  if (currentPage > totalPage) {
    return (0, _i18n.getI18nMessage)('search.lastPage');
  }

  if (currentPage === 1) {
    return (0, _i18n.getI18nMessage)('search.firstPage');
  }

  return (0, _i18n.getI18nMessage)('search.middlePage');
};

exports.renderInfo = renderInfo;

var renderData = function renderData(currentResultList, searchKey, withJson) {
  if (currentResultList instanceof Array && currentResultList.length > 0) {
    withJson ? console.log(JSON.stringify(currentResultList, null, 4)) : console.table(currentResultList.map(function (_ref6) {
      var name = _ref6.name,
          version = _ref6.version,
          description = _ref6.manifest.description;
      return {
        name: (0, _helpers.tableColumnRender)(name, 30),
        version: (0, _helpers.tableColumnRender)(version, 20),
        description: (0, _helpers.tableColumnRender)(description || (0, _i18n.getI18nMessage)('common.noDescription'), 50)
      };
    }), ['name', 'version', 'description']);
  } else {
    _i18n["default"].log('search.noResult', {
      searchKey: searchKey ? "\"".concat(searchKey, "\"") : ''
    });
  }

  withJson ? console.log('') : _i18n["default"].log('search.moreInfo');
};

exports.renderData = renderData;

function addDefaultTemplateIntoData(data, currentPage, type) {
  if (type === 'template' && currentPage === 1 && data instanceof Array) {
    var templatePath = _path["default"].join(__dirname, '..', 'asset', 'template', 'default');

    var dirs = _fs["default"].readdirSync(templatePath);

    dirs.forEach(function (d) {
      var jsonPath = _path["default"].join(templatePath, d);

      var parsed = _path["default"].parse(d);

      if (parsed.name && parsed.ext === ".json" && _fs["default"].existsSync(jsonPath)) {
        var json = JSON.parse(_fs["default"].readFileSync(jsonPath));
        data.unshift({
          name: json.name,
          version: 'latest',
          manifest: {
            description: json.description
          }
        });
      }
    });
  }
}