"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.uninstall = uninstall;
exports.unInstallBundle = unInstallBundle;
exports.getAllRemovingDependencies = getAllRemovingDependencies;

var _path = _interopRequireDefault(require("path"));

var _bundle = require("../core/bundle");

var _repository = require("../core/repository");

var _constant = require("../constant/constant");

var _config = require("../utils/config");

var _helpers = require("../utils/helpers");

var _i18n = _interopRequireWildcard(require("../i18n"));

var _events = _interopRequireWildcard(require("../utils/events"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function uninstall(_x) {
  return _uninstall.apply(this, arguments);
}

function _uninstall() {
  _uninstall = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(descriptor) {
    var options,
        repo,
        bundle,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
            repo = null;

            if (options.global) {
              repo = new _repository.Repository('', (0, _config.getGlobalRepo)());
            } else {
              repo = new _repository.Repository(_path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME), (0, _config.getGlobalRepo)());
            }

            bundle = _bundle.Bundle.from((0, _config.getRootBundlePath)(options.global));
            _context.next = 6;
            return unInstallBundle(bundle, repo, descriptor, {
              isGlobal: options.global,
              type: options.saveDev ? 'dev' : ''
            });

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _uninstall.apply(this, arguments);
}

function unInstallBundle(_x2, _x3, _x4) {
  return _unInstallBundle.apply(this, arguments);
}

function _unInstallBundle() {
  _unInstallBundle = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(bundle, repo, descriptor) {
    var _ref,
        isGlobal,
        type,
        nameList,
        afterInstallCmds,
        removingList,
        repoManifests,
        manifests,
        _args2 = arguments;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _ref = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : {}, isGlobal = _ref.isGlobal, type = _ref.type;
            nameList = parseDescriptor(descriptor);
            afterInstallCmds = [];
            removingList = [];

            if (checkDependencies(bundle, nameList, type)) {
              repoManifests = isGlobal ? repo.globalManifests() : repo.manifests();
              manifests = [].concat(_toConsumableArray(repoManifests), [bundle.manifest]);
              removingList = getAllRemovingDependencies(nameList, manifests, bundle);
              removingList.forEach(function (name) {
                var found = manifests.find(function (m) {
                  return m.name === name;
                });
                var preUninstallCmd = found && (found.scripts(_constant.Hooks.uninstall) || found.scripts(_constant.Hooks.preUninstall));

                if (preUninstallCmd) {
                  (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
                    return spawnSync(preUninstallCmd, {
                      shell: process.env.shellPath,
                      cwd: found && found.path,
                      stdio: 'inherit'
                    });
                  });
                }

                _events["default"].emit('hooks', {
                  type: _events.EventTypes.beforeUninstall,
                  name: name,
                  path: found && found.path
                });

                var afterCmd = found && found.scripts(_constant.Hooks.afterUninstall);

                if (afterCmd) {
                  afterInstallCmds.push({
                    name: found.name,
                    cmd: afterCmd
                  });
                }
              });
              repo.remove(removingList, isGlobal);
              bundle.removeDependencies(removingList, type);
              bundle.updateBundleJson();

              if (!isGlobal) {
                bundle.updateLockJsonForUnInstall(removingList);
              }
            }

            _i18n["default"].log('uninstall.complete');

            if (afterInstallCmds.length > 0) {
              afterInstallCmds.forEach(function (_ref2) {
                var name = _ref2.name,
                    cmd = _ref2.cmd;
                (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
                  return spawnSync(cmd, {
                    shell: process.env.shellPath,
                    cwd: bundle.path,
                    stdio: 'inherit'
                  });
                });
              });
            }

            removingList.forEach(function (name) {
              _events["default"].emit('hooks', {
                type: _events.EventTypes.afterUninstall,
                name: name
              });
            });

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _unInstallBundle.apply(this, arguments);
}

function parseDescriptor(descriptor) {
  return String(descriptor).split(',').map(function (name) {
    return name.trim();
  });
}

function getAllRemovingDependencies(nameList, manifests, rootBundle) {
  var _initDependenciesMap = (0, _helpers.initDependenciesMap)(manifests),
      dependencies = _initDependenciesMap.dependencies,
      dependents = _initDependenciesMap.dependents;

  var stack = [].concat(nameList);
  var removing = new Set();

  while (stack.length > 0) {
    var name = stack.pop();
    removing.add(name);
    var dependenciesSet = dependencies.get(name) || new Set();
    var dependenciesArray = Array.from(dependenciesSet.values());
    stack = stack.concat(dependenciesArray);
  }

  var findAllDependents = function findAllDependents(name) {
    var directDependentSet = dependents.get(name) || new Set();
    var ignoreRootBundle = !directDependentSet.has(rootBundle.name);
    var tempStack = [name];
    var result = [];

    while (tempStack.length > 0) {
      var current = tempStack.pop();

      if (current === rootBundle.name && ignoreRootBundle) {// do nothing
      } else {
        result.push(current);
        var dependentSet = dependents.get(current) || new Set();
        var dependentArray = Array.from(dependentSet.values());
        tempStack = tempStack.concat(dependentArray);
      }
    }

    return result;
  };

  var _iterator = _createForOfIteratorHelper(removing),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var _name = _step.value;

      if (!nameList.includes(_name)) {
        var allDependents = findAllDependents(_name);
        var found = allDependents.find(function (d) {
          return !removing.has(d);
        });

        if (found) {
          removing["delete"](_name);
        }
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  return Array.from(removing.values());
}

function checkDependencies(bundle, nameList, type) {
  var dependencies = type === 'dev' ? bundle.manifest.devDependencies : bundle.dependencies;

  var _iterator2 = _createForOfIteratorHelper(nameList),
      _step2;

  try {
    var _loop = function _loop() {
      var name = _step2.value;

      if (!dependencies.find(function (d) {
        return d.name === name;
      })) {
        throw (0, _i18n.getI18nMessage)('uninstall.noDep', {
          name: name
        });
      }
    };

    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      _loop();
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }

  return true;
}