"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getNameToBundle = getNameToBundle;
exports.checkRiskManifests = checkRiskManifests;
exports.Bundle = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _glob = _interopRequireDefault(require("glob"));

var _path2 = _interopRequireDefault(require("path"));

var _manifest2 = require("./manifest");

var _dependency = require("./dependency");

var _variable = require("./variable");

var _dependencyGraph = require("./dependency-graph");

var _repository = require("./repository");

var _bundleLock2 = require("./bundle-lock");

var _helpers = require("../utils/helpers");

var _constant = require("../constant/constant");

var _i18n = _interopRequireWildcard(require("../i18n"));

var _log = _interopRequireDefault(require("./log"));

var _axios = _interopRequireDefault(require("../utils/axios"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var _path = new WeakMap();

var _manifest = new WeakMap();

var _manifests = new WeakMap();

var _vars = new WeakMap();

var _bundleLock = new WeakMap();

var Bundle = /*#__PURE__*/function () {
  function Bundle(bundlePath, manifest) {
    _classCallCheck(this, Bundle);

    _path.set(this, {
      writable: true,
      value: void 0
    });

    _manifest.set(this, {
      writable: true,
      value: void 0
    });

    _manifests.set(this, {
      writable: true,
      value: void 0
    });

    _vars.set(this, {
      writable: true,
      value: void 0
    });

    _bundleLock.set(this, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _path, bundlePath);

    _classPrivateFieldSet(this, _manifest, manifest);

    var _tags = {};
    var _config = {};

    var _iterator = _createForOfIteratorHelper(this.dependencies),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var dependency = _step.value;

        if (dependency.tag) {
          _tags[dependency.tag] = (_tags[dependency.tag] ? _tags[dependency.tag] : []).concat([dependency.name]);
        }

        if (dependency.params) _config[dependency.name] = dependency.params;
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    this.dependencies.tags = _tags;
    this.dependencies.config = _config;
    _classPrivateFieldGet(this, _manifest).path = bundlePath;

    _classPrivateFieldSet(this, _vars, new _variable.Variable());

    if (_fs["default"].existsSync(_path2["default"].join(_classPrivateFieldGet(this, _path), 'bundle-lock.json'))) {
      _classPrivateFieldSet(this, _bundleLock, _bundleLock2.BundleLock.fromUrl(_classPrivateFieldGet(this, _path)));
    }
  }

  _createClass(Bundle, [{
    key: "vars",
    get: function get() {
      return _classPrivateFieldGet(this, _vars);
    }
  }, {
    key: "manifest",
    get: function get() {
      return _classPrivateFieldGet(this, _manifest);
    }
  }, {
    key: "name",
    get: function get() {
      return _classPrivateFieldGet(this, _manifest).name;
    }
  }, {
    key: "id",
    get: function get() {
      return this.manifest.id;
    }
  }, {
    key: "scripts",
    value: function scripts(name) {
      return _classPrivateFieldGet(this, _manifest).scripts(name);
    }
  }, {
    key: "dependencies",
    get: function get() {
      return _classPrivateFieldGet(this, _manifest).dependencies;
    }
  }, {
    key: "path",
    get: function get() {
      return _classPrivateFieldGet(this, _path);
    }
  }, {
    key: "binary",
    get: function get() {
      return _classPrivateFieldGet(this, _path);
    }
  }, {
    key: "lock",
    get: function get() {
      return _classPrivateFieldGet(this, _bundleLock);
    }
  }, {
    key: "copy",
    value: function copy() {
      var dirs = _classPrivateFieldGet(this, _manifest).dirs();

      var result = {};

      if (dirs) {
        Object.keys(dirs).forEach(function (key) {
          var pattern = dirs[key];

          if (typeof pattern === 'string' && pattern.startsWith('@')) {
            result[key] = pattern.substr(1);
          }
        });
      }

      return result;
    }
  }, {
    key: "link",
    value: function link() {
      var dirs = _classPrivateFieldGet(this, _manifest).dirs();

      var result = [];

      if (dirs) {
        Object.keys(dirs).forEach(function (key) {
          var pattern = dirs[key];

          if (typeof pattern === 'string' && pattern.startsWith('&')) {
            result.push({
              source: pattern.substring(1),
              target: key
            });
          }
        });
      }

      return result;
    }
  }, {
    key: "files",
    value: function files(dir) {
      var _this = this;

      var patterns = _classPrivateFieldGet(this, _manifest).dirs(dir);

      if (patterns) {
        return (Array.isArray(patterns) ? patterns : [patterns]).flatMap(function (pattern) {
          return _glob["default"].sync(_path2["default"].normalize("".concat(_classPrivateFieldGet(_this, _path), "/").concat(pattern)));
        });
      }

      return [];
    }
  }, {
    key: "pack",
    value: function pack() {
      var _this2 = this;

      if (!_classPrivateFieldGet(this, _manifest).publishAs) {
        throw (0, _i18n.getI18nMessage)('bundle.missingPublishAs');
      }

      if (!_classPrivateFieldGet(this, _manifest).license.trim()) {
        throw (0, _i18n.getI18nMessage)('bundle.missingLicense');
      }

      var packConfig = getDefaultPackConfig(_classPrivateFieldGet(this, _path));

      if (['source', 'distribution', 'binary', 'plugin'].some(this.isPublishAs.bind(this))) {
        var dirs = _classPrivateFieldGet(this, _manifest).dirs();

        if (dirs) {
          Object.keys(dirs).forEach(function (key) {
            if (typeof dirs[key] === 'string' && (dirs[key].startsWith('@') || dirs[key].startsWith('&'))) {
              return;
            }

            packConfig[key] = (packConfig[key] || []).concat(_this2.files(key));
          });
        }

        return packConfig;
      }

      return null; // code-segment
    }
  }, {
    key: "build",
    value: function () {
      var _build = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(repo) {
        var manifests, bundles, _iterator2, _step2, manifest, bundle;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.install(repo, false);

              case 2:
                manifests = _context.sent;
                bundles = [];
                _iterator2 = _createForOfIteratorHelper(manifests);
                _context.prev = 5;

                _iterator2.s();

              case 7:
                if ((_step2 = _iterator2.n()).done) {
                  _context.next = 15;
                  break;
                }

                manifest = _step2.value;
                _context.next = 11;
                return Bundle.mapManifestToBundle(manifest);

              case 11:
                bundle = _context.sent;
                bundles.push(bundle);

              case 13:
                _context.next = 7;
                break;

              case 15:
                _context.next = 20;
                break;

              case 17:
                _context.prev = 17;
                _context.t0 = _context["catch"](5);

                _iterator2.e(_context.t0);

              case 20:
                _context.prev = 20;

                _iterator2.f();

                return _context.finish(20);

              case 23:
                return _context.abrupt("return", _variable.Variable.compute(bundles));

              case 24:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[5, 17, 20, 23]]);
      }));

      function build(_x) {
        return _build.apply(this, arguments);
      }

      return build;
    }()
  }, {
    key: "isPublishAs",
    value: function isPublishAs(publishAs) {
      return this.manifest.publishAs === publishAs;
    }
  }, {
    key: "install",
    value: function () {
      var _install = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(repo, isGlobal) {
        var _yield$this$traverse, manifests, isFromBundleLock;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.traverse(repo, isGlobal);

              case 2:
                _yield$this$traverse = _context2.sent;
                manifests = _yield$this$traverse.manifests;
                isFromBundleLock = _yield$this$traverse.isFromBundleLock;

                if (!(!isFromBundleLock && !isGlobal)) {
                  _context2.next = 8;
                  break;
                }

                _context2.next = 8;
                return this.updateLockJsonForInstall(manifests);

              case 8:
                _context2.next = 10;
                return checkRiskManifests(manifests);

              case 10:
                _classPrivateFieldSet(this, _manifests, manifests);

                return _context2.abrupt("return", manifests);

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function install(_x2, _x3) {
        return _install.apply(this, arguments);
      }

      return install;
    }()
  }, {
    key: "traverse",
    value: function () {
      var _traverse = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(repo) {
        var manifests, isFromBundleLock, manifestGraph, _manifestGraph;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                manifests = [];
                isFromBundleLock = false;

                if (!(_classPrivateFieldGet(this, _bundleLock) && _classPrivateFieldGet(this, _bundleLock).isCompatible(this.dependencies, repo.globalManifests().map(function (m) {
                  return m.name;
                })))) {
                  _context3.next = 10;
                  break;
                }

                _context3.next = 5;
                return _dependencyGraph.DependencyGraph.buildFromLock(this, _classPrivateFieldGet(this, _bundleLock), repo);

              case 5:
                manifestGraph = _context3.sent;
                manifests = manifestGraph.traverse();
                isFromBundleLock = true;
                _context3.next = 14;
                break;

              case 10:
                _context3.next = 12;
                return _dependencyGraph.DependencyGraph.build(this, repo);

              case 12:
                _manifestGraph = _context3.sent;
                manifests = _manifestGraph.traverse();

              case 14:
                return _context3.abrupt("return", {
                  manifests: manifests,
                  isFromBundleLock: isFromBundleLock
                });

              case 15:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function traverse(_x4) {
        return _traverse.apply(this, arguments);
      }

      return traverse;
    }()
  }, {
    key: "update",
    value: function () {
      var _update = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(repo) {
        var _this3 = this;

        var localManifests, globalManifests, manifestGraph, remoteManifests, needUpdate;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                localManifests = repo.manifests();
                globalManifests = repo.globalManifests();
                _context4.next = 4;
                return _dependencyGraph.DependencyGraph.build(this, repo.remoteRepo);

              case 4:
                manifestGraph = _context4.sent;
                remoteManifests = manifestGraph.traverse();
                needUpdate = {};
                remoteManifests.forEach(function (remote) {
                  if (remote.name === _this3.manifest.name) {
                    return;
                  }

                  var local = localManifests.find(function (localManifest) {
                    return localManifest.name === remote.name;
                  });

                  if (local) {
                    if (local.version.version !== remote.version.version) {
                      needUpdate[remote.name] = {
                        local: local.version.version,
                        global: '',
                        remote: remote.version.version
                      };
                    }
                  } else {
                    var global = globalManifests.find(function (m) {
                      return m.name === remote.name;
                    });

                    if (global) {
                      if (global.version.version !== remote.version.version) {
                        needUpdate[remote.name] = {
                          local: 'miss',
                          global: global.version.version,
                          remote: remote.version.version
                        };
                      }
                    } else {
                      needUpdate[remote.name] = {
                        local: 'miss',
                        global: 'miss',
                        remote: remote.version.version
                      };
                    }
                  }
                });
                return _context4.abrupt("return", needUpdate);

              case 9:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function update(_x5) {
        return _update.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "addDependencies",
    value: function addDependencies(dependencies, type) {
      _classPrivateFieldGet(this, _manifest).addDependencies(dependencies, type);
    }
  }, {
    key: "removeDependencies",
    value: function removeDependencies(names, type) {
      var _this4 = this;

      var baseName = names.find(function (name) {
        var bName = _this4.manifest.base && _this4.manifest.base.name;
        return bName === name;
      });

      if (baseName) {
        _classPrivateFieldGet(this, _manifest).removeBase({
          name: baseName
        });
      }

      _classPrivateFieldGet(this, _manifest).removeDependencies(names, type);
    }
  }, {
    key: "updateDependencies",
    value: function updateDependencies(dependencies, type) {
      var _this5 = this;

      var newDependencies = [];
      var base = null;

      var _iterator3 = _createForOfIteratorHelper(dependencies),
          _step3;

      try {
        var _loop = function _loop() {
          var dep = _step3.value;

          var manifest = _classPrivateFieldGet(_this5, _manifests).find(function (m) {
            return m.name === dep.name;
          });

          if (manifest) {
            var versionRanges = dep.versionRanges && dep.versionRanges !== '*' ? dep.versionRanges : "~".concat(manifest.version.version);

            if (manifest.publishAs === 'distribution') {
              base = {
                name: dep.name,
                version: versionRanges
              };
            } else {
              newDependencies.push(new _dependency.Dependency(dep.name, versionRanges));
            }
          }
        };

        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          _loop();
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      if (base) {
        _classPrivateFieldGet(this, _manifest).updateBase(base);
      }

      if (newDependencies.length > 0) {
        _classPrivateFieldGet(this, _manifest).updateDependencies(newDependencies, type);
      }
    }
  }, {
    key: "updateBundleJson",
    value: function updateBundleJson() {
      var json = this.manifest.json();

      _fs["default"].writeFileSync(_path2["default"].join(_classPrivateFieldGet(this, _path), 'bundle.json'), JSON.stringify(json, null, 4));
    }
  }, {
    key: "updateLockJsonForInstall",
    value: function () {
      var _updateLockJsonForInstall = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(manifests) {
        var needUpdateManifests;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (!_classPrivateFieldGet(this, _bundleLock)) {
                  _context5.next = 5;
                  break;
                }

                needUpdateManifests = manifests.filter(function (m) {
                  return !!m.url;
                });

                _classPrivateFieldGet(this, _bundleLock).addOrUpdate(needUpdateManifests);

                _context5.next = 12;
                break;

              case 5:
                _context5.t0 = _classPrivateFieldSet;
                _context5.t1 = this;
                _context5.t2 = _bundleLock;
                _context5.next = 10;
                return _bundleLock2.BundleLock.fromManifests(manifests);

              case 10:
                _context5.t3 = _context5.sent;
                (0, _context5.t0)(_context5.t1, _context5.t2, _context5.t3);

              case 12:
                if (_classPrivateFieldGet(this, _bundleLock)) {
                  _classPrivateFieldGet(this, _bundleLock).saveToFile(_classPrivateFieldGet(this, _path));
                }

              case 13:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function updateLockJsonForInstall(_x6) {
        return _updateLockJsonForInstall.apply(this, arguments);
      }

      return updateLockJsonForInstall;
    }()
  }, {
    key: "updateLockJsonForUnInstall",
    value: function updateLockJsonForUnInstall(manifestNameList) {
      if (_classPrivateFieldGet(this, _bundleLock)) {
        _classPrivateFieldGet(this, _bundleLock).remove(manifestNameList);

        _classPrivateFieldGet(this, _bundleLock).saveToFile(_classPrivateFieldGet(this, _path));
      }
    }
  }]);

  return Bundle;
}();

exports.Bundle = Bundle;

Bundle.from = function (dir) {
  var manifest = _manifest2.Manifest.fromPath(dir);

  return new Bundle(dir, manifest);
};

Bundle.mapManifestToBundle = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(manifest) {
    var bundlePath;
    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            bundlePath = manifest.path;

            if (!manifest.url) {
              _context6.next = 5;
              break;
            }

            _context6.next = 4;
            return (0, _repository.bundleDownload)(manifest, false);

          case 4:
            bundlePath = _context6.sent;

          case 5:
            return _context6.abrupt("return", Bundle.from(bundlePath));

          case 6:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));

  return function (_x7) {
    return _ref.apply(this, arguments);
  };
}();

function getNameToBundle(bundles) {
  var result = new Map();

  var _iterator4 = _createForOfIteratorHelper(bundles),
      _step4;

  try {
    for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
      var bundle = _step4.value;
      result.set(bundle.name, bundle);
    }
  } catch (err) {
    _iterator4.e(err);
  } finally {
    _iterator4.f();
  }

  return result;
}

function getDefaultPackConfig(bundlePath) {
  var autoPackFiles = [{
    name: 'bundle.json',
    required: true
  }, {
    name: 'README.md',
    required: true
  }, {
    name: 'LICENSE',
    required: true
  }, {
    name: 'AUTHOR',
    required: false
  }, {
    name: 'README_EN.md',
    required: false
  }, {
    name: 'README_CN.md',
    required: false
  }, {
    name: 'CHANGELOG.md',
    required: false
  }, {
    name: 'CHANGELOG_EN.md',
    required: false
  }, {
    name: 'CHANGELOG_CN.md',
    required: false
  }];
  var packConfig = {
    '.': []
  };
  autoPackFiles.forEach(function (_ref2) {
    var name = _ref2.name,
        required = _ref2.required;

    var filePath = _path2["default"].join(bundlePath, name);

    if (_fs["default"].existsSync(filePath)) {
      packConfig['.'].push(filePath);

      var stats = _fs["default"].statSync(filePath);

      if (stats.size === 0) {
        throw (0, _i18n.getI18nMessage)('bundle.fileShouldNotEmpty', {
          name: name
        });
      }
    } else if (required) {
      throw (0, _i18n.getI18nMessage)('bundle.fileRequired', {
        name: name
      });
    }
  });
  return packConfig;
}

function checkRiskManifests(_x8) {
  return _checkRiskManifests.apply(this, arguments);
}

function _checkRiskManifests() {
  _checkRiskManifests = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(manifests) {
    var otherManifests, licenses, response, riskManifests;
    return regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            if (manifests) {
              _context7.next = 2;
              break;
            }

            return _context7.abrupt("return");

          case 2:
            otherManifests = manifests.slice(0, manifests.length - 1); // 最后一个manifest为root manifest

            licenses = [];
            _context7.prev = 4;
            _context7.next = 7;
            return _axios["default"].get(_helpers.URL.licenses(""));

          case 7:
            response = _context7.sent;

            if (!(response && response.data && response.data.code === 200)) {
              _context7.next = 15;
              break;
            }

            licenses = response.data.data && response.data.data.license || [];
            riskManifests = otherManifests.filter(function (m) {
              var licenseName = m.license || '';
              var isMatch = false;
              licenses.forEach(function (licenseReg) {
                if (!isMatch) {
                  var reg = new RegExp(licenseReg, 'gi');
                  isMatch = reg.test(licenseName.trim());
                }
              });
              return !isMatch;
            });
            printRiskWarn(riskManifests);
            return _context7.abrupt("return", riskManifests);

          case 15:
            throw -1;

          case 16:
            _context7.next = 22;
            break;

          case 18:
            _context7.prev = 18;
            _context7.t0 = _context7["catch"](4);

            _log["default"].warnConsole((0, _i18n.getI18nMessage)('license.uncheck'));

            return _context7.abrupt("return", _context7.t0);

          case 22:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7, null, [[4, 18]]);
  }));
  return _checkRiskManifests.apply(this, arguments);
}

function printRiskWarn(riskManifests) {
  riskManifests.forEach(function (rm) {
    _log["default"].warnConsole((0, _i18n.getI18nMessage)('license.warn', {
      bundleName: rm.name,
      license: rm.license || 'empty'
    }));
  });
}