"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.download = download;
exports.cleanBundlesFolder = cleanBundlesFolder;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _crypto = _interopRequireDefault(require("./crypto"));

var _axios = _interopRequireDefault(require("../utils/axios"));

var _helpers = require("../utils/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function download(_x, _x2) {
  return _download.apply(this, arguments);
}

function _download() {
  _download = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(manifest, savePath) {
    var saveFilePath, response, writeStream;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            saveFilePath = _path["default"].resolve(savePath, "".concat(manifest.id, ".tgz"));
            _context.next = 3;
            return (0, _axios["default"])({
              method: 'GET',
              url: manifest.url,
              responseType: 'stream'
            });

          case 3:
            response = _context.sent;
            writeStream = _fs["default"].createWriteStream(saveFilePath);
            response.data.pipe(writeStream);
            return _context.abrupt("return", new Promise(function (resolve, reject) {
              writeStream.on('close', function () {
                if (manifest.checksum && manifest.checksum !== _crypto["default"].digest(saveFilePath)) {
                  reject("".concat(manifest.name, " has been modified"));
                } else {
                  resolve(savePath);
                }
              });
              writeStream.on('error', reject);
            }));

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _download.apply(this, arguments);
}

function cleanBundlesFolder(ohosPath) {
  if (_fs["default"].existsSync(ohosPath)) {
    (0, _helpers.runShellCmd)(function (shell) {
      return shell.rm('-rf', ohosPath);
    });
  }
}