"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RemoteRepository = void 0;

var _semver = _interopRequireDefault(require("semver"));

var _axios = require("../utils/axios");

var _helpers = require("../utils/helpers");

var _manifest2 = require("./manifest");

var _i18n = require("../i18n");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var RemoteRepository = /*#__PURE__*/function () {
  function RemoteRepository() {
    _classCallCheck(this, RemoteRepository);
  }

  _createClass(RemoteRepository, [{
    key: "resolve",
    value: function () {
      var _resolve = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(manifest) {
        var depsManifest, _iterator, _step, dep, versionRanges, d;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                depsManifest = [];
                _iterator = _createForOfIteratorHelper(manifest.dependencies);
                _context.prev = 2;

                _iterator.s();

              case 4:
                if ((_step = _iterator.n()).done) {
                  _context.next = 15;
                  break;
                }

                dep = _step.value;
                versionRanges = dep.versionRanges;
                _context.next = 9;
                return this.manifest(dep.name, versionRanges);

              case 9:
                d = _context.sent;

                if (d) {
                  _context.next = 12;
                  break;
                }

                throw (0, _i18n.getI18nMessage)('repository.unResolved', {
                  name: dep.name
                });

              case 12:
                depsManifest.push(d);

              case 13:
                _context.next = 4;
                break;

              case 15:
                _context.next = 20;
                break;

              case 17:
                _context.prev = 17;
                _context.t0 = _context["catch"](2);

                _iterator.e(_context.t0);

              case 20:
                _context.prev = 20;

                _iterator.f();

                return _context.finish(20);

              case 23:
                return _context.abrupt("return", depsManifest);

              case 24:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[2, 17, 20, 23]]);
      }));

      function resolve(_x) {
        return _resolve.apply(this, arguments);
      }

      return resolve;
    }()
  }, {
    key: "manifest",
    value: function () {
      var _manifest = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(name, range) {
        var _yield$axios$get, data, manifests, found, manifest, bundleManifest;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return _axios.axios.get("".concat(_helpers.URL.bundles(name), "/").concat(name));

              case 2:
                _yield$axios$get = _context2.sent;
                data = _yield$axios$get.data.data;
                manifests = data || [];

                if (!(manifests.length === 0)) {
                  _context2.next = 7;
                  break;
                }

                throw (0, _i18n.getI18nMessage)('repository.unResolved', {
                  name: name
                });

              case 7:
                found = manifests.filter(function (m) {
                  return _semver["default"].satisfies(m.version, range, {
                    includePrerelease: true
                  });
                });

                if (!(found.length === 0)) {
                  _context2.next = 10;
                  break;
                }

                return _context2.abrupt("return", null);

              case 10:
                manifest = found.reduce(function (m, c) {
                  return _semver["default"].lt(m.version, c.version) ? c : m;
                }, found[0]);

                if (!(!manifest || !manifest.manifest)) {
                  _context2.next = 13;
                  break;
                }

                return _context2.abrupt("return", null);

              case 13:
                bundleManifest = _manifest2.Manifest.json(manifest.manifest, {
                  download: manifest.download
                });
                return _context2.abrupt("return", bundleManifest);

              case 15:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function manifest(_x2, _x3) {
        return _manifest.apply(this, arguments);
      }

      return manifest;
    }()
  }]);

  return RemoteRepository;
}();

exports.RemoteRepository = RemoteRepository;