"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bundleDownload = bundleDownload;
exports.createDirIfNotExists = createDirIfNotExists;
exports.extract = extract;
exports.Repository = void 0;

require("@babel/polyfill");

var _tar = _interopRequireDefault(require("tar"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _remoteRepository = require("./remote-repository");

var _helpers = require("../utils/helpers");

var _helpers2 = require("./helpers");

var _localRepository = require("./local-repository");

var _constant = require("../constant/constant");

var _i18n = _interopRequireWildcard(require("../i18n"));

var _variable = require("./variable");

var _events = _interopRequireWildcard(require("../utils/events"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var _localRepo = new WeakMap();

var _globalRepo = new WeakMap();

var _remoteRepo = new WeakMap();

var Repository = /*#__PURE__*/function () {
  function Repository(localRepoPath, globalRepoPath) {
    _classCallCheck(this, Repository);

    _localRepo.set(this, {
      writable: true,
      value: void 0
    });

    _globalRepo.set(this, {
      writable: true,
      value: void 0
    });

    _remoteRepo.set(this, {
      writable: true,
      value: void 0
    });

    if (localRepoPath) {
      _classPrivateFieldSet(this, _localRepo, new _localRepository.LocalRepository(localRepoPath));
    }

    if (globalRepoPath) {
      _classPrivateFieldSet(this, _globalRepo, new _localRepository.LocalRepository(globalRepoPath));
    }

    _classPrivateFieldSet(this, _remoteRepo, new _remoteRepository.RemoteRepository());
  }

  _createClass(Repository, [{
    key: "remoteRepo",
    get: function get() {
      return _classPrivateFieldGet(this, _remoteRepo);
    }
  }, {
    key: "path",
    get: function get() {
      return _classPrivateFieldGet(this, _localRepo) && _classPrivateFieldGet(this, _localRepo).path;
    }
  }, {
    key: "globalRepoPath",
    get: function get() {
      return _classPrivateFieldGet(this, _globalRepo) && _classPrivateFieldGet(this, _globalRepo).path;
    }
  }, {
    key: "manifests",
    value: function manifests() {
      return _classPrivateFieldGet(this, _localRepo) ? _classPrivateFieldGet(this, _localRepo).manifests() : [];
    }
  }, {
    key: "globalManifests",
    value: function globalManifests() {
      return _classPrivateFieldGet(this, _globalRepo) ? _classPrivateFieldGet(this, _globalRepo).manifests() : [];
    }
  }, {
    key: "resolve",
    value: function () {
      var _resolve = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(manifest, rootManifest) {
        var result, depManifest, dependencies, _iterator, _step, dependency, name, versionRanges;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                result = [];
                depManifest = null;
                dependencies = manifest.getCompositeDependencies(rootManifest);
                _iterator = _createForOfIteratorHelper(dependencies);
                _context.prev = 4;

                _iterator.s();

              case 6:
                if ((_step = _iterator.n()).done) {
                  _context.next = 23;
                  break;
                }

                dependency = _step.value;
                name = dependency.name, versionRanges = dependency.versionRanges;

                if (_classPrivateFieldGet(this, _localRepo)) {
                  depManifest = _classPrivateFieldGet(this, _localRepo).manifest(name, versionRanges);
                }

                if (!depManifest && _classPrivateFieldGet(this, _globalRepo)) {
                  depManifest = _classPrivateFieldGet(this, _globalRepo).manifest(name, versionRanges);
                }

                if (!(!depManifest && this.remoteRepo)) {
                  _context.next = 15;
                  break;
                }

                _context.next = 14;
                return this.remoteRepo.manifest(name, versionRanges);

              case 14:
                depManifest = _context.sent;

              case 15:
                if (depManifest) {
                  _context.next = 19;
                  break;
                }

                throw (0, _i18n.getI18nMessage)('repository.unResolved', {
                  name: dependency.name
                });

              case 19:
                result.push(depManifest);

              case 20:
                depManifest = null;

              case 21:
                _context.next = 6;
                break;

              case 23:
                _context.next = 28;
                break;

              case 25:
                _context.prev = 25;
                _context.t0 = _context["catch"](4);

                _iterator.e(_context.t0);

              case 28:
                _context.prev = 28;

                _iterator.f();

                return _context.finish(28);

              case 31:
                return _context.abrupt("return", result);

              case 32:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[4, 25, 28, 31]]);
      }));

      function resolve(_x, _x2) {
        return _resolve.apply(this, arguments);
      }

      return resolve;
    }()
  }, {
    key: "suspend",
    value: function suspend(nameList, isGlobal) {
      this.delegate('suspend', isGlobal, nameList);
    }
  }, {
    key: "deleteSuspend",
    value: function deleteSuspend(isGlobal) {
      this.delegate('deleteSuspend', isGlobal);
    }
  }, {
    key: "restoreSuspend",
    value: function restoreSuspend(isGlobal) {
      this.delegate('restoreSuspend', isGlobal);
    }
  }, {
    key: "remove",
    value: function remove(nameList, isGlobal) {
      this.delegate('remove', isGlobal, nameList);
    }
  }, {
    key: "delegate",
    value: function delegate(methodName, isGlobal) {
      for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        args[_key - 2] = arguments[_key];
      }

      if (isGlobal && _classPrivateFieldGet(this, _globalRepo)) {
        var _classPrivateFieldGet2;

        (_classPrivateFieldGet2 = _classPrivateFieldGet(this, _globalRepo))[methodName].apply(_classPrivateFieldGet2, args);
      } else if (!isGlobal && _classPrivateFieldGet(this, _localRepo)) {
        var _classPrivateFieldGet3;

        (_classPrivateFieldGet3 = _classPrivateFieldGet(this, _localRepo))[methodName].apply(_classPrivateFieldGet3, args);
      } else {
        throw (0, _i18n.getI18nMessage)('repository.depFolderNotExisted', {
          name: _constant.DEP_FOLDER_NAME
        });
      }
    }
  }]);

  return Repository;
}();

exports.Repository = Repository;

function bundleDownload(_x3, _x4) {
  return _bundleDownload.apply(this, arguments);
}

function _bundleDownload() {
  _bundleDownload = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(manifest, isGlobal) {
    var installPath, nameInfo, dirPath, manifestPath, preInstallCmd, bundlePath;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            installPath = isGlobal ? process.env.globalRepo : process.cwd();
            nameInfo = (0, _helpers.parseScopeName)(manifest.name);
            dirPath = _path["default"].resolve(_path["default"].join(installPath, _constant.DEP_FOLDER_NAME, nameInfo.scope, nameInfo.name));
            manifestPath = _path["default"].resolve(dirPath, "".concat(manifest.id, ".tgz"));
            createDirIfNotExists(dirPath);
            preInstallCmd = (manifest.scripts || {})[_constant.Hooks.preInstall];

            if (preInstallCmd) {
              (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
                return spawnSync(preInstallCmd, {
                  shell: process.env.shellPath,
                  env: _variable.Variable.basicEnv(installPath),
                  cwd: dirPath,
                  stdio: 'inherit'
                });
              });
            }

            _events["default"].emit('hooks', {
              type: _events.EventTypes.beforeEachInstall,
              name: manifest.name
            });

            _context2.next = 10;
            return (0, _helpers2.download)(manifest, dirPath).then(function (dirPath) {
              extract(manifestPath, dirPath);
              return dirPath;
            }).then(function (dirPath) {
              (0, _helpers.runShellCmd)(function (shell) {
                return shell.rm(manifestPath);
              });
              return dirPath;
            });

          case 10:
            bundlePath = _context2.sent;
            return _context2.abrupt("return", bundlePath);

          case 12:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _bundleDownload.apply(this, arguments);
}

function createDirIfNotExists(dirName, basePath) {
  var targetDir = _path["default"].join(basePath || '', dirName);

  if (!_fs["default"].existsSync(targetDir)) {
    (0, _helpers.runShellCmd)(function (shell) {
      return shell.mkdir('-p', targetDir);
    });
  }
}

function extract(manifestPath, dirPath) {
  _i18n["default"].log('repository.extract', {
    filePath: manifestPath
  });

  _tar["default"].extract({
    file: manifestPath,
    cwd: dirPath,
    sync: true
  });
}