"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isPlugin = isPlugin;
exports["default"] = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _constant = require("../constant/constant");

var _bundle = require("../core/bundle");

var _helpers = require("../core/helpers");

var _manifest = require("../core/manifest");

var _repository = require("../core/repository");

var _config = require("../utils/config");

var _register = require("./register");

var _commands = require("../commands");

var _events = require("../utils/events");

var _axios = _interopRequireDefault(require("../utils/axios"));

var _helpers2 = require("../utils/helpers");

var _rcParser = _interopRequireDefault(require("../core/rc-parser"));

var _preference = _interopRequireDefault(require("../core/preference"));

var _shelljs = _interopRequireDefault(require("shelljs"));

var _semver = _interopRequireDefault(require("semver"));

var _i18n = require("../i18n");

var _dependency = require("../core/dependency");

var _i18nAPI = _interopRequireDefault(require("./i18nAPI"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var _cmdPlugins = new WeakMap();

var _hooks = new WeakMap();

var _cwd = new WeakMap();

var _runAction = new WeakMap();

var _program = new WeakMap();

var _defaultCommands = new WeakMap();

var PluginAPI = /*#__PURE__*/function () {
  function PluginAPI(cwd, runAction, program) {
    _classCallCheck(this, PluginAPI);

    _cmdPlugins.set(this, {
      writable: true,
      value: void 0
    });

    _hooks.set(this, {
      writable: true,
      value: void 0
    });

    _cwd.set(this, {
      writable: true,
      value: void 0
    });

    _runAction.set(this, {
      writable: true,
      value: void 0
    });

    _program.set(this, {
      writable: true,
      value: void 0
    });

    _defaultCommands.set(this, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _cmdPlugins, {});

    _classPrivateFieldSet(this, _hooks, {});

    _classPrivateFieldSet(this, _cwd, cwd);

    _classPrivateFieldSet(this, _program, program);

    _classPrivateFieldSet(this, _runAction, runAction);

    _classPrivateFieldSet(this, _defaultCommands, _toConsumableArray(program.commands));
  }

  _createClass(PluginAPI, [{
    key: "registerPlugins",
    value: function registerPlugins() {
      var api = this;

      var _classPrivateFieldGet2 = _classPrivateFieldGet(this, _program),
          program = _classPrivateFieldGet2.program;

      program.commands = _classPrivateFieldGet(this, _defaultCommands);
      (0, _register.resolveNpmPlugins)(api);
      (0, _register.resolveCmdPlugins)(api);
      var plugins = api.getCmdPlugins();
      Object.keys(plugins).forEach(function (name) {
        var plugin = plugins[name];

        if (plugin.action) {
          var allNames = program.commands.map(function (c) {
            return c.name();
          });

          if (allNames.includes(name)) {
            console.log((0, _i18n.getI18nMessage)('plugin.registerCmdError', {
              name: name
            }));
          } else {
            var command = program.command(name).action(function () {
              for (var _len = arguments.length, argsWithCommander = new Array(_len), _key = 0; _key < _len; _key++) {
                argsWithCommander[_key] = arguments[_key];
              }

              var commanderArg = argsWithCommander.find(function (argWithCommander) {
                return argWithCommander && typeof argWithCommander.opts === 'function';
              });
              plugin.action(commanderArg.opts(), commanderArg.args);
            });

            var _ref = plugin.options || {},
                description = _ref.description,
                options = _ref.options,
                args = _ref.args;

            if (description) {
              command.description(description);
            }

            if (options) {
              Object.keys(options).forEach(function (key) {
                command.option(key, options[key]);
              });
            }

            if (args) {
              command.arguments(args);
            }
          }
        }
      });
      (0, _register.registerPluginHooks)(api);
    }
  }, {
    key: "eventTypes",
    get: function get() {
      return _events.EventTypes;
    }
  }, {
    key: "i18n",
    get: function get() {
      return _i18nAPI["default"];
    }
  }, {
    key: "_bundle",
    get: function get() {
      this.cwdCheck();

      var jsonFile = _path["default"].join(this.cwd(), 'bundle.json');

      if (_fs["default"].existsSync(jsonFile)) {
        return _bundle.Bundle.from(this.cwd());
      }

      return null;
    }
  }, {
    key: "_repo",
    get: function get() {
      this.cwdCheck();
      return new _repository.Repository(_path["default"].join(this.cwd(), _constant.DEP_FOLDER_NAME), (0, _config.getGlobalRepo)());
    }
  }, {
    key: "cwdCheck",
    value: function cwdCheck() {
      var cwd = process.cwd();

      if (_classPrivateFieldGet(this, _cwd) !== cwd) {
        _classPrivateFieldSet(this, _cmdPlugins, {});

        _classPrivateFieldSet(this, _hooks, {});

        _classPrivateFieldSet(this, _cwd, cwd);

        (0, _register.resolveCmdPlugins)(this);
        (0, _register.registerPluginHooks)(this);
      }
    }
  }, {
    key: "registerCmd",
    value: function registerCmd(name, options, action, isUiTask) {
      this.cwdCheck();

      if (!_classPrivateFieldGet(this, _cmdPlugins)[name]) {
        _classPrivateFieldGet(this, _cmdPlugins)[name] = {};
      }

      _classPrivateFieldGet(this, _cmdPlugins)[name]['options'] = options;
      _classPrivateFieldGet(this, _cmdPlugins)[name]['action'] = action;
      _classPrivateFieldGet(this, _cmdPlugins)[name]['isUiTask'] = isUiTask;
    }
  }, {
    key: "on",
    value: function on(type, action) {
      this.cwdCheck();

      if (!_classPrivateFieldGet(this, _hooks)[type]) {
        _classPrivateFieldGet(this, _hooks)[type] = [];
      }

      if (this.eventTypes[type]) {
        _classPrivateFieldGet(this, _hooks)[type].push(action);
      }
    }
  }, {
    key: "bundlesDir",
    value: function bundlesDir(isGlobal) {
      if (isGlobal) {
        return (0, _config.getGlobalRepo)();
      }

      return _path["default"].resolve(_path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME));
    }
  }, {
    key: "clean",
    value: function clean() {
      var ohosFolder = this.bundlesDir();
      (0, _helpers.cleanBundlesFolder)(ohosFolder);
    }
  }, {
    key: "save",
    value: function save(manifest) {
      var bundlePath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : process.cwd();

      if (!_fs["default"].existsSync(bundlePath)) {
        _shelljs["default"].mkdir('-p', bundlePath);
      }

      var bundle = new _bundle.Bundle(bundlePath, _manifest.Manifest.json(manifest));
      bundle.updateBundleJson();
    }
  }, {
    key: "cwd",
    value: function cwd() {
      return _classPrivateFieldGet(this, _cwd);
    }
  }, {
    key: "init",
    value: function () {
      var _init = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _ref2,
            name,
            template,
            scope,
            dirname,
            _args = arguments;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _ref2 = _args.length > 0 && _args[0] !== undefined ? _args[0] : {}, name = _ref2.name, template = _ref2.template, scope = _ref2.scope, dirname = _ref2.dirname;
                _context.next = 3;
                return _classPrivateFieldGet(this, _runAction).call(this, "init", [name, {
                  template: template,
                  scope: scope,
                  dirname: dirname
                }]);

              case 3:
                return _context.abrupt("return", _context.sent);

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init() {
        return _init.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: "install",
    value: function () {
      var _install = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(names) {
        var _ref3,
            global,
            saveDev,
            namesString,
            _args2 = arguments;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _ref3 = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : {}, global = _ref3.global, saveDev = _ref3.saveDev;

                if (names && names.length > 0) {
                  namesString = names.join(',');
                }

                _context2.next = 4;
                return _classPrivateFieldGet(this, _runAction).call(this, "install", [namesString, {
                  global: global,
                  saveDev: saveDev
                }]);

              case 4:
                return _context2.abrupt("return", _context2.sent);

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function install(_x) {
        return _install.apply(this, arguments);
      }

      return install;
    }()
  }, {
    key: "remove",
    value: function () {
      var _remove = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(names) {
        var _ref4,
            global,
            saveDev,
            namesString,
            _args3 = arguments;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _ref4 = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {}, global = _ref4.global, saveDev = _ref4.saveDev;

                if (names && names.length > 0) {
                  namesString = names.join(',');
                }

                _context3.next = 4;
                return _classPrivateFieldGet(this, _runAction).call(this, "uninstall", [namesString, {
                  global: global,
                  saveDev: saveDev
                }]);

              case 4:
                return _context3.abrupt("return", _context3.sent);

              case 5:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function remove(_x2) {
        return _remove.apply(this, arguments);
      }

      return remove;
    }()
  }, {
    key: "update",
    value: function () {
      var _update = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(names) {
        var _ref5,
            global,
            namesString,
            _args4 = arguments;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _ref5 = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : {}, global = _ref5.global;

                if (names && names.length > 0) {
                  namesString = names.join(',');
                }

                _context4.next = 4;
                return _classPrivateFieldGet(this, _runAction).call(this, "update", [namesString, {
                  global: global
                }]);

              case 4:
                return _context4.abrupt("return", _context4.sent);

              case 5:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function update(_x3) {
        return _update.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "run",
    value: function () {
      var _run = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(name) {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return _classPrivateFieldGet(this, _runAction).call(this, "run", [name]);

              case 2:
                return _context5.abrupt("return", _context5.sent);

              case 3:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function run(_x4) {
        return _run.apply(this, arguments);
      }

      return run;
    }()
  }, {
    key: "getConfig",
    value: function getConfig() {
      var rcParser = _rcParser["default"].fromPath(_constant.DEFAULT_CONFIG_FILE);

      return rcParser.toJson();
    }
  }, {
    key: "setConfig",
    value: function setConfig(config) {
      var rcParser = _rcParser["default"].fromPath(_constant.DEFAULT_CONFIG_FILE);

      Object.keys(config).forEach(function (key) {
        rcParser.set(key, config[key].toString());
      });
      rcParser.save();
    }
  }, {
    key: "deleteConfig",
    value: function deleteConfig(configKeys) {
      var rcParser = _rcParser["default"].fromPath(_constant.DEFAULT_CONFIG_FILE);

      configKeys.forEach(function (key) {
        rcParser["delete"](key);
      });
      rcParser.save();
    }
  }, {
    key: "getScriptHooks",
    value: function getScriptHooks() {
      return Object.values(_constant.Hooks);
    }
  }, {
    key: "list",
    value: function () {
      var _list = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(deep) {
        var _yield$this$_bundle$t, manifests, dependencies;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                if (!this._bundle) {
                  _context6.next = 9;
                  break;
                }

                _context6.next = 3;
                return this._bundle.traverse(this._repo);

              case 3:
                _yield$this$_bundle$t = _context6.sent;
                manifests = _yield$this$_bundle$t.manifests;

                if (!deep) {
                  _context6.next = 7;
                  break;
                }

                return _context6.abrupt("return", manifests);

              case 7:
                dependencies = this._bundle.manifest.dependencies;
                return _context6.abrupt("return", dependencies.map(function (d) {
                  return manifests.find(function (m) {
                    return m.name === d.name;
                  });
                }).concat(this._bundle.manifest));

              case 9:
                return _context6.abrupt("return", []);

              case 10:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function list(_x5) {
        return _list.apply(this, arguments);
      }

      return list;
    }()
  }, {
    key: "getManifest",
    value: function getManifest() {
      if (this._bundle) {
        return this._bundle.manifest;
      }

      return null;
    }
  }, {
    key: "getPluginManifests",
    value: function getPluginManifests() {
      var localManifests = this.getManifests();
      var global = this.getManifests(true);
      var total = global.filter(function (manifest) {
        return !localManifests.find(function (m) {
          return m.name === manifest.name;
        });
      }).concat(localManifests).concat((0, _register.getNpmManifests)());
      ;
      var filtered = total.filter(isPlugin);
      return filtered;
    }
  }, {
    key: "checkUpdate",
    value: function () {
      var _checkUpdate = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
        var needUpdate;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                if (!this._bundle) {
                  _context7.next = 5;
                  break;
                }

                _context7.next = 3;
                return this._bundle.update(this._repo);

              case 3:
                needUpdate = _context7.sent;
                return _context7.abrupt("return", needUpdate);

              case 5:
                return _context7.abrupt("return", []);

              case 6:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function checkUpdate() {
        return _checkUpdate.apply(this, arguments);
      }

      return checkUpdate;
    }()
  }, {
    key: "getManifests",
    value: function getManifests(isGlobal) {
      if (isGlobal) {
        return this._repo.globalManifests();
      }

      return this._repo.manifests();
    }
  }, {
    key: "getDependencies",
    value: function () {
      var _getDependencies = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(name, allManifests) {
        var manifests, manifest;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.t0 = allManifests;

                if (_context8.t0) {
                  _context8.next = 5;
                  break;
                }

                _context8.next = 4;
                return this.list(true);

              case 4:
                _context8.t0 = _context8.sent;

              case 5:
                manifests = _context8.t0;
                manifest = manifests.find(function (m) {
                  return m.name === name;
                });

                if (!manifest) {
                  _context8.next = 9;
                  break;
                }

                return _context8.abrupt("return", manifest.dependencies.filter(function (d) {
                  return d instanceof _dependency.Dependency;
                }));

              case 9:
                return _context8.abrupt("return", []);

              case 10:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function getDependencies(_x6, _x7) {
        return _getDependencies.apply(this, arguments);
      }

      return getDependencies;
    }()
  }, {
    key: "getCmdPlugins",
    value: function getCmdPlugins() {
      this.cwdCheck();
      return _classPrivateFieldGet(this, _cmdPlugins);
    }
  }, {
    key: "getHooks",
    value: function getHooks() {
      this.cwdCheck();
      return _classPrivateFieldGet(this, _hooks);
    }
  }, {
    key: "getTemplates",
    value: function getTemplates() {
      return _shelljs["default"].ls('-l', _path["default"].join(__dirname, '..', 'asset', 'template', 'default')).map(function (fstat) {
        return _path["default"].join(__dirname, '..', 'asset', 'template', 'default', fstat.name);
      });
    }
  }, {
    key: "getVersion",
    value: function getVersion() {
      return JSON.parse(_fs["default"].readFileSync(_path["default"].join(__dirname, '..', '..', 'package.json')).toString()).version;
    }
  }, {
    key: "getValidator",
    value: function getValidator() {
      return _objectSpread({}, _manifest.Manifest.Validator);
    }
  }, {
    key: "search",
    value: function () {
      var _search = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(_ref6) {
        var searchKey, publishAs, curPage, pageSize, ver, matchBy, currentPageNum, pageSizeNum, params;
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                searchKey = _ref6.searchKey, publishAs = _ref6.publishAs, curPage = _ref6.curPage, pageSize = _ref6.pageSize, ver = _ref6.ver;
                matchBy = [];

                if (searchKey) {
                  matchBy.push({
                    field: 'name',
                    opt: 'CONTAIN',
                    value: searchKey
                  });
                }

                if (publishAs) {
                  matchBy.push({
                    field: 'publishAs',
                    opt: 'EQUAL',
                    value: publishAs
                  });
                }

                if (ver && (ver === 'latest' || ver === 'all' || _semver["default"].validRange(ver))) {
                  matchBy.push({
                    field: 'version',
                    opt: 'EQUAL',
                    value: ver
                  });
                }

                currentPageNum = Number(curPage);
                pageSizeNum = Number(pageSize);
                params = {
                  pageSize: pageSizeNum,
                  condition: JSON.stringify({
                    matchBy: matchBy
                  }),
                  curPage: currentPageNum
                };
                _context9.next = 10;
                return _axios["default"].get(_helpers2.URL.search(searchKey), {
                  params: params
                });

              case 10:
                return _context9.abrupt("return", _context9.sent);

              case 11:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9);
      }));

      function search(_x8) {
        return _search.apply(this, arguments);
      }

      return search;
    }()
  }, {
    key: "setRecentProject",
    value: function setRecentProject(name, projectPath, isDelete) {
      _preference["default"].setRecentProject(name, projectPath, isDelete);
    }
  }, {
    key: "getRecentProject",
    value: function getRecentProject() {
      return _preference["default"].getRecentProject();
    }
  }, {
    key: "addDisabledPlugin",
    value: function addDisabledPlugin(name) {
      _preference["default"].addDisabledPlugin(name);

      (0, _register.resolveCmdPlugins)(this);
      (0, _register.registerPluginHooks)(this);
    }
  }, {
    key: "removeDisabledPlugin",
    value: function removeDisabledPlugin(name) {
      _preference["default"].removeDisabledPlugin(name);

      (0, _register.resolveCmdPlugins)(this);
      (0, _register.registerPluginHooks)(this);
    }
  }, {
    key: "getDisabledPlugins",
    value: function getDisabledPlugins() {
      return _preference["default"].getDisabledPlugins();
    }
  }, {
    key: "getScopeRegistry",
    value: function getScopeRegistry(name) {
      return (0, _helpers2.getScopeRegistry)(name);
    }
  }, {
    key: "getRemoteBundleDetails",
    value: function () {
      var _getRemoteBundleDetails = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(name) {
        var apiUrl, _yield$axios$get, data;

        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                apiUrl = this.getScopeRegistry(name);
                _context10.next = 3;
                return _axios["default"].get("".concat(apiUrl, "/detail/").concat(name));

              case 3:
                _yield$axios$get = _context10.sent;
                data = _yield$axios$get.data;
                return _context10.abrupt("return", data);

              case 6:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function getRemoteBundleDetails(_x9) {
        return _getRemoteBundleDetails.apply(this, arguments);
      }

      return getRemoteBundleDetails;
    }()
  }, {
    key: "getLocalBundle",
    value: function getLocalBundle(name) {
      var manifests = this.getManifests().concat(this.getManifests(true));

      if (this._bundle) {
        this._bundle.manifest.path = this._bundle.path;
        manifests.push(this._bundle.manifest);
      }

      return manifests.find(function (m) {
        return m.name === name;
      });
    }
  }, {
    key: "getRemoteReadme",
    value: function () {
      var _getRemoteReadme = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(url) {
        var _yield$axios$get2, data;

        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return _axios["default"].get(url);

              case 2:
                _yield$axios$get2 = _context11.sent;
                data = _yield$axios$get2.data;
                return _context11.abrupt("return", data);

              case 5:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11);
      }));

      function getRemoteReadme(_x10) {
        return _getRemoteReadme.apply(this, arguments);
      }

      return getRemoteReadme;
    }()
  }, {
    key: "setLanguage",
    value: function setLanguage(value) {
      var supportLanguages = (0, _i18n.getSupportLang)();

      if (!supportLanguages.includes(value)) {
        throw (0, _i18n.getI18nMessage)('lang.err', {
          supportLanguages: supportLanguages
        });
      }

      return _preference["default"].set('lang', value, true);
    }
  }, {
    key: "getLanguage",
    value: function getLanguage() {
      return _preference["default"].get('lang');
    }
  }, {
    key: "registToOutput",
    value: function registToOutput(dirname) {
      var bundlePath = dirname;

      while (!_fs["default"].existsSync(_path["default"].join(bundlePath, "bundle.json"))) {
        var upperDir = _path["default"].resolve(bundlePath, "..");

        if (bundlePath === upperDir) {
          throw (0, _i18n.getI18nMessage)("manifest.notFoundJson");
        } else {
          bundlePath = upperDir;
        }
      }

      var manifest = _manifest.Manifest.fromPath(bundlePath);

      var _parseScopeName = (0, _helpers2.parseScopeName)(manifest.name),
          scope = _parseScopeName.scope,
          name = _parseScopeName.name;

      var outputPath = _path["default"].join(this.cwd(), _constant.DEP_FOLDER_NAME, _constant.DATA_OUTPUT_FOLDER, scope, name);

      if (_fs["default"].existsSync(outputPath)) {
        _shelljs["default"].rm("-r", outputPath);
      }

      _shelljs["default"].mkdir('-p', outputPath);

      _shelljs["default"].cp("-r", "".concat(bundlePath, "/*"), outputPath);
    }
  }, {
    key: "getDefaultCmds",
    value: function getDefaultCmds(publishAs) {
      return _commands.defaultCmdConfigs.filter(function (_ref7) {
        var isBundleDefaultCmd = _ref7.isBundleDefaultCmd;
        return isBundleDefaultCmd(publishAs);
      }).map(function (_ref8) {
        var name = _ref8.name,
            description = _ref8.description;
        return {
          name: name,
          description: description
        };
      });
    }
  }]);

  return PluginAPI;
}();

exports["default"] = PluginAPI;

function isPlugin(manifest) {
  return manifest.publishAs === "plugin";
}