"use strict";

require("@babel/polyfill");

var _build = require("../commands/build");

var _bundle = require("../core/bundle");

var _i18n = _interopRequireDefault(require("../i18n"));

var _log = _interopRequireDefault(require("../core/log"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _require = require('worker_threads'),
    workerData = _require.workerData;

var bundlePath = workerData.bundlePath,
    isStartBundle = workerData.isStartBundle,
    bundleVarValues = workerData.bundleVarValues,
    customizeArgs = workerData.customizeArgs;

try {
  var bundle = _bundle.Bundle.from(bundlePath);

  bundle.vars.merge(bundleVarValues);
  (0, _build.bundleBuild)(bundle, isStartBundle, customizeArgs);
} catch (error) {
  _i18n["default"].log('build.error', {
    error: error
  });

  _log["default"].debug(error);

  process.exit(-1);
}