"use strict";

require("@babel/polyfill");

var _repository = require("../core/repository");

var _i18n = _interopRequireDefault(require("../i18n"));

var _log = _interopRequireDefault(require("../core/log"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _require = require('worker_threads'),
    workerData = _require.workerData,
    parentPort = _require.parentPort;

var manifest = workerData.manifest,
    isGlobal = workerData.isGlobal;
(0, _repository.bundleDownload)(manifest, isGlobal).then(function (bundlePath) {
  manifest.path = bundlePath;
  parentPort.postMessage(bundlePath);
})["catch"](function (err) {
  _i18n["default"].log('install.error', {
    error: err
  });

  _log["default"].debug(err);

  process.exit(-1);
});